# 1 "rpcdebug.c"
 












# 1 "/usr/include/sys/types.h" 1 3



# 1 "/usr/include/linux/types.h" 1 3



# 1 "/usr/include/linux/posix_types.h" 1 3



 









 










 


















typedef struct {
	unsigned long fds_bits [(1024 / (8 * sizeof(unsigned long)) ) ];
} __kernel_fd_set;

 
typedef void (*__kernel_sighandler_t)(int);

 
typedef int __kernel_key_t;

# 1 "/usr/include/asm/posix_types.h" 1 3



 





typedef unsigned short	__kernel_dev_t;
typedef unsigned long	__kernel_ino_t;
typedef unsigned short	__kernel_mode_t;
typedef unsigned short	__kernel_nlink_t;
typedef long		__kernel_off_t;
typedef int		__kernel_pid_t;
typedef unsigned short	__kernel_ipc_pid_t;
typedef unsigned short	__kernel_uid_t;
typedef unsigned short	__kernel_gid_t;
typedef unsigned int	__kernel_size_t;
typedef int		__kernel_ssize_t;
typedef int		__kernel_ptrdiff_t;
typedef long		__kernel_time_t;
typedef long		__kernel_suseconds_t;
typedef long		__kernel_clock_t;
typedef int		__kernel_daddr_t;
typedef char *		__kernel_caddr_t;


typedef long long	__kernel_loff_t;


typedef struct {



	int	__val[2];

} __kernel_fsid_t;



























# 54 "/usr/include/linux/posix_types.h" 2 3



# 4 "/usr/include/linux/types.h" 2 3

# 1 "/usr/include/asm/types.h" 1 3



typedef unsigned short umode_t;

 




typedef __signed__ char __s8;
typedef unsigned char __u8;

typedef __signed__ short __s16;
typedef unsigned short __u16;

typedef __signed__ int __s32;
typedef unsigned int __u32;


typedef __signed__ long long __s64;
typedef unsigned long long __u64;


 


# 42 "/usr/include/asm/types.h" 3



# 5 "/usr/include/linux/types.h" 2 3




typedef __kernel_fd_set		fd_set;
typedef __kernel_dev_t		dev_t;
typedef __kernel_ino_t		ino_t;
typedef __kernel_mode_t		mode_t;
typedef __kernel_nlink_t	nlink_t;
typedef __kernel_off_t		off_t;
typedef __kernel_pid_t		pid_t;
typedef __kernel_uid_t		uid_t;
typedef __kernel_gid_t		gid_t;
typedef __kernel_daddr_t	daddr_t;
typedef __kernel_key_t		key_t;
typedef __kernel_suseconds_t	suseconds_t;


typedef __kernel_loff_t		loff_t;


 





typedef __kernel_size_t		size_t;




typedef __kernel_ssize_t	ssize_t;




typedef __kernel_ptrdiff_t	ptrdiff_t;




typedef __kernel_time_t		time_t;




typedef __kernel_clock_t	clock_t;




typedef __kernel_caddr_t	caddr_t;


 
typedef unsigned char		u_char;
typedef unsigned short		u_short;
typedef unsigned int		u_int;
typedef unsigned long		u_long;

 
typedef unsigned char		unchar;
typedef unsigned short		ushort;
typedef unsigned int		uint;
typedef unsigned long		ulong;



 




struct ustat {
	__kernel_daddr_t	f_tfree;
	__kernel_ino_t		f_tinode;
	char			f_fname[6];
	char			f_fpack[6];
};


# 4 "/usr/include/sys/types.h" 2 3

# 1 "/usr/include/sys/bitypes.h" 1 3
 



 






















































 













	 



	typedef   char            int8_t;
	typedef unsigned char            u_int8_t;
	typedef short                     int16_t;
	typedef unsigned short          u_int16_t;
	typedef int                       int32_t;
	typedef unsigned int            u_int32_t;


	typedef long long                 int64_t;
	typedef unsigned long long      u_int64_t;




 
# 5 "/usr/include/sys/types.h" 2 3










 
typedef unsigned long fd_mask;


# 14 "rpcdebug.c" 2

# 1 "/usr/include/linux/nfs_fs.h" 1 3
 










# 1 "/usr/include/linux/signal.h" 1 3



# 1 "/usr/include/asm/signal.h" 1 3





 
struct siginfo;

# 23 "/usr/include/asm/signal.h" 3

 


typedef unsigned long sigset_t;


































 





 



 



























# 112 "/usr/include/asm/signal.h" 3






 
typedef void (*__sighandler_t)(int);





# 143 "/usr/include/asm/signal.h" 3

 

struct sigaction {
	__sighandler_t sa_handler;
	sigset_t sa_mask;
	unsigned long sa_flags;
	void (*sa_restorer)(void);
};


typedef struct sigaltstack {
	void *ss_sp;
	int ss_flags;
	size_t ss_size;
} stack_t;

# 202 "/usr/include/asm/signal.h" 3



# 4 "/usr/include/linux/signal.h" 2 3

# 1 "/usr/include/asm/siginfo.h" 1 3





 

typedef union sigval {
	int sival_int;
	void *sival_ptr;
} sigval_t;




typedef struct siginfo {
	int si_signo;
	int si_errno;
	int si_code;

	union {
		int _pad[((128 /sizeof(int)) - 3) ];

		 
		struct {
			pid_t _pid;		 
			uid_t _uid;		 
		} _kill;

		 
		struct {
			unsigned int _timer1;
			unsigned int _timer2;
		} _timer;

		 
		struct {
			pid_t _pid;		 
			uid_t _uid;		 
			sigval_t _sigval;
		} _rt;

		 
		struct {
			pid_t _pid;		 
			int _status;		 
			clock_t _utime;
			clock_t _stime;
		} _sigchld;

		 
		struct {
			void *_addr;  
		} _sigfault;

		 
		struct {
			int _band;	 
			int _fd;
		} _sigpoll;
	} _sifields;
} siginfo_t;

 














 













 












 












 






 







 






 










 










 














typedef struct sigevent {
	sigval_t sigev_value;
	int sigev_signo;
	int sigev_notify;
	union {
		int _pad[((64 /sizeof(int)) - 3) ];

		struct {
			void (*_function)(sigval_t);
			void *_attribute;	 
		} _sigev_thread;
	} _sigev_un;
} sigevent_t;





# 5 "/usr/include/linux/signal.h" 2 3


# 203 "/usr/include/linux/signal.h" 3



# 12 "/usr/include/linux/nfs_fs.h" 2 3

# 1 "/usr/include/linux/sched.h" 1 3



# 1 "/usr/include/asm/param.h" 1 3




















# 4 "/usr/include/linux/sched.h" 2 3


extern unsigned long event;

# 1 "/usr/include/linux/binfmts.h" 1 3



# 1 "/usr/include/linux/ptrace.h" 1 3


 
 

 

















# 1 "/usr/include/asm/ptrace.h" 1 3






















 


struct pt_regs {
	long ebx;
	long ecx;
	long edx;
	long esi;
	long edi;
	long ebp;
	long eax;
	int  xds;
	int  xes;
	long orig_eax;
	long eip;
	int  xcs;
	long eflags;
	long esp;
	int  xss;
};

 












# 24 "/usr/include/linux/ptrace.h" 2 3



# 4 "/usr/include/linux/binfmts.h" 2 3


 






 


struct linux_binprm{
	char buf[128];
	unsigned long page[32 ];
	unsigned long p;
	int sh_bang;
	int java;		 
	struct dentry * dentry;
	int e_uid, e_gid;
	int argc, envc;
	char * filename;	 
	unsigned long loader, exec;
};

 



struct linux_binfmt {
	struct linux_binfmt * next;
	struct module *module;
	int (*load_binary)(struct linux_binprm *, struct  pt_regs * regs);
	int (*load_shlib)(int fd);
	int (*core_dump)(long signr, struct pt_regs * regs);
};

extern int register_binfmt(struct linux_binfmt *);
extern int unregister_binfmt(struct linux_binfmt *);

extern int read_exec(struct dentry *, unsigned long offset,
	char * addr, unsigned long count, int to_kmem);

extern int open_dentry(struct dentry *, int mode);

extern int init_elf_binfmt(void);
extern int init_elf32_binfmt(void);
extern int init_aout_binfmt(void);
extern int init_aout32_binfmt(void);
extern int init_script_binfmt(void);
extern int init_java_binfmt(void);
extern int init_em86_binfmt(void);
extern int init_misc_binfmt(void);

extern int prepare_binprm(struct linux_binprm *);
extern void remove_arg_zero(struct linux_binprm *);
extern int search_binary_handler(struct linux_binprm *,struct pt_regs *);
extern int flush_old_exec(struct linux_binprm * bprm);
extern unsigned long setup_arg_pages(unsigned long p, struct linux_binprm * bprm);
extern unsigned long copy_strings(int argc,char ** argv,unsigned long *page,
		unsigned long p, int from_kmem);

 



# 8 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/personality.h" 1 3



# 1 "/usr/include/linux/linkage.h" 1 3






























# 41 "/usr/include/linux/linkage.h" 3



# 4 "/usr/include/linux/personality.h" 2 3




 



 












 
typedef void (*lcall7_func)(struct pt_regs *);


 




struct exec_domain {
	const char *name;
	lcall7_func handler;
	unsigned char pers_low, pers_high;
	unsigned long * signal_map;
	unsigned long * signal_invmap;
	struct module * module;
	struct exec_domain *next;
};

extern struct exec_domain default_exec_domain;

extern struct exec_domain *lookup_exec_domain(unsigned long personality);
extern int register_exec_domain(struct exec_domain *it);
extern int unregister_exec_domain(struct exec_domain *it);
  int sys_personality(unsigned long personality);


# 9 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/tasks.h" 1 3



 


 












 





# 10 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/kernel.h" 1 3



 



# 83 "/usr/include/linux/kernel.h" 3



struct sysinfo {
	long uptime;			 
	unsigned long loads[3];		 
	unsigned long totalram;		 
	unsigned long freeram;		 
	unsigned long sharedram;	 
	unsigned long bufferram;	 
	unsigned long totalswap;	 
	unsigned long freeswap;		 
	unsigned short procs;		 
	char _f[22];			 
};


# 11 "/usr/include/linux/sched.h" 2 3


# 1 "/usr/include/linux/times.h" 1 3



struct tms {
	clock_t tms_utime;
	clock_t tms_stime;
	clock_t tms_cutime;
	clock_t tms_cstime;
};


# 13 "/usr/include/linux/sched.h" 2 3


# 1 "/usr/include/asm/system.h" 1 3



# 1 "/usr/include/asm/segment.h" 1 3










# 4 "/usr/include/asm/system.h" 2 3


 


























 







 








 
# 89 "/usr/include/asm/system.h" 3


# 109 "/usr/include/asm/system.h" 3



# 122 "/usr/include/asm/system.h" 3


# 135 "/usr/include/asm/system.h" 3




static inline unsigned long _get_base(char * addr)
{
	unsigned long __base;
	__asm__("movb %3,%%dh\n\t"
		"movb %2,%%dl\n\t"
		"shll $16,%%edx\n\t"
		"movw %1,%%dx"
		:"=&d" (__base)
		:"m" (*((addr)+2)),
		 "m" (*((addr)+4)),
		 "m" (*((addr)+7)));
	return __base;
}



static inline unsigned long get_limit(unsigned long segment)
{
	unsigned long __limit;
	__asm__("lsll %1,%0"
		:"=r" (__limit):"r" (segment));
	return __limit+1;
}



 
















struct __xchg_dummy { unsigned long a[100]; };


 


static inline unsigned long __xchg(unsigned long x, void * ptr, int size)
{
	switch (size) {
		case 1:
			__asm__("xchgb %b0,%1"
				:"=q" (x)
				:"m" (* ((struct __xchg_dummy *)( ptr )) ), "0" (x)
				:"memory");
			break;
		case 2:
			__asm__("xchgw %w0,%1"
				:"=r" (x)
				:"m" (* ((struct __xchg_dummy *)( ptr )) ), "0" (x)
				:"memory");
			break;
		case 4:
			__asm__("xchgl %0,%1"
				:"=r" (x)
				:"m" (* ((struct __xchg_dummy *)( ptr )) ), "0" (x)
				:"memory");
			break;
	}
	return x;
}



 








# 235 "/usr/include/asm/system.h" 3










# 254 "/usr/include/asm/system.h" 3














# 276 "/usr/include/asm/system.h" 3


# 287 "/usr/include/asm/system.h" 3






 



extern struct desc_struct default_ldt;

 



void disable_hlt(void);
void enable_hlt(void);


# 15 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/asm/semaphore.h" 1 3





 
















# 1 "/usr/include/asm/atomic.h" 1 3



 










 









typedef struct { int counter; } atomic_t;







static __inline__ void atomic_add(int i, volatile atomic_t *v)
{
	__asm__ __volatile__(
		""  "addl %1,%0"
		:"=m" ((*(volatile struct { int a[100]; } *) v ) )
		:"ir" (i), "m" ((*(volatile struct { int a[100]; } *) v ) ));
}

static __inline__ void atomic_sub(int i, volatile atomic_t *v)
{
	__asm__ __volatile__(
		""  "subl %1,%0"
		:"=m" ((*(volatile struct { int a[100]; } *) v ) )
		:"ir" (i), "m" ((*(volatile struct { int a[100]; } *) v ) ));
}

static __inline__ void atomic_inc(volatile atomic_t *v)
{
	__asm__ __volatile__(
		""  "incl %0"
		:"=m" ((*(volatile struct { int a[100]; } *) v ) )
		:"m" ((*(volatile struct { int a[100]; } *) v ) ));
}

static __inline__ void atomic_dec(volatile atomic_t *v)
{
	__asm__ __volatile__(
		""  "decl %0"
		:"=m" ((*(volatile struct { int a[100]; } *) v ) )
		:"m" ((*(volatile struct { int a[100]; } *) v ) ));
}

static __inline__ int atomic_dec_and_test(volatile atomic_t *v)
{
	unsigned char c;

	__asm__ __volatile__(
		""  "decl %0; sete %1"
		:"=m" ((*(volatile struct { int a[100]; } *) v ) ), "=qm" (c)
		:"m" ((*(volatile struct { int a[100]; } *) v ) ));
	return c != 0;
}

 









# 23 "/usr/include/asm/semaphore.h" 2 3


struct semaphore {
	atomic_t count;
	int waking;
	struct wait_queue * wait;
};




  void __down_failed(void  );
  int  __down_failed_interruptible(void   );
  void __up_wakeup(void  );

extern void __down(struct semaphore * sem);
extern void __up(struct semaphore * sem);



 










static inline void wake_one_more(struct semaphore * sem)
{
	unsigned long flags;

	__asm__ __volatile__("pushfl ; popl %0":"=g" (  flags  ):   :"memory")  ;
	__asm__ __volatile__ ("cli": : :"memory")  ;
	sem->waking++;
	__asm__ __volatile__("pushl %0 ; popfl":   :"g" (  flags  ):"memory")  ;
}

static inline int waking_non_zero(struct semaphore *sem)
{
	unsigned long flags;
	int ret = 0;

	__asm__ __volatile__("pushfl ; popl %0":"=g" (  flags  ):   :"memory")  ;
	__asm__ __volatile__ ("cli": : :"memory")  ;
	if (sem->waking > 0) {
		sem->waking--;
		ret = 1;
	}
	__asm__ __volatile__("pushl %0 ; popfl":   :"g" (  flags  ):"memory")  ;
	return ret;
}

 




extern inline void down(struct semaphore * sem)
{
	__asm__ __volatile__(
		"# atomic down operation\n\t"



		"decl 0(%0)\n\t"
		"js 2f\n"
		"1:\n"
		".section .text.lock,\"ax\"\n"
		"2:\tpushl $1b\n\t"
		"jmp __down_failed\n"
		".previous"
		: 
		:"c" (sem)
		:"memory");
}

extern inline int down_interruptible(struct semaphore * sem)
{
	int result;

	__asm__ __volatile__(
		"# atomic interruptible down operation\n\t"



		"decl 0(%1)\n\t"
		"js 2f\n\t"
		"xorl %0,%0\n"
		"1:\n"
		".section .text.lock,\"ax\"\n"
		"2:\tpushl $1b\n\t"
		"jmp __down_failed_interruptible\n"
		".previous"
		:"=a" (result)
		:"c" (sem)
		:"memory");
	return result;
}


 





extern inline void up(struct semaphore * sem)
{
	__asm__ __volatile__(
		"# atomic up operation\n\t"



		"incl 0(%0)\n\t"
		"jle 2f\n"
		"1:\n"
		".section .text.lock,\"ax\"\n"
		"2:\tpushl $1b\n\t"
		"jmp __up_wakeup\n"
		".previous"
		: 
		:"c" (sem)
		:"memory");
}


# 16 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/asm/page.h" 1 3



 




# 65 "/usr/include/asm/page.h" 3



# 17 "/usr/include/linux/sched.h" 2 3


# 1 "/usr/include/linux/smp.h" 1 3



 




# 42 "/usr/include/linux/smp.h" 3


 


 








# 19 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/tty.h" 1 3



 



 






		 


# 372 "/usr/include/linux/tty.h" 3


# 20 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/sem.h" 1 3



# 1 "/usr/include/linux/ipc.h" 1 3







struct ipc_perm
{
	__kernel_key_t	key;
	__kernel_uid_t	uid;
	__kernel_gid_t	gid;
	__kernel_uid_t	cuid;
	__kernel_gid_t	cgid;
	__kernel_mode_t	mode; 
	unsigned short	seq;
};

 





 



















# 4 "/usr/include/linux/sem.h" 2 3


 


 








 



 
struct semid_ds {
	struct ipc_perm	sem_perm;		 
	__kernel_time_t	sem_otime;		 
	__kernel_time_t	sem_ctime;		 
	struct sem	*sem_base;		 
	struct sem_queue *sem_pending;		 
	struct sem_queue **sem_pending_last;	 
	struct sem_undo	*undo;			 
	unsigned short	sem_nsems;		 
};

 
struct sembuf {
	unsigned short  sem_num;	 
	short		sem_op;		 
	short		sem_flg;	 
};

 
union semun {
	int val;			 
	struct semid_ds *buf;		 
	unsigned short *array;		 
	struct seminfo *__buf;		 
	void *__pad;
};

struct  seminfo {
	int semmap;
	int semmni;
	int semmns;
	int semmnu;
	int semmsl;
	int semopm;
	int semume;
	int semusz;
	int semvmx;
	int semaem;
};







 






# 111 "/usr/include/linux/sem.h" 3



# 21 "/usr/include/linux/sched.h" 2 3



 









 









extern unsigned long avenrun[];		 
















extern int nr_running, nr_tasks;
extern int last_pid;

# 1 "/usr/include/linux/head.h" 1 3



struct desc_struct {
	unsigned long a,b;
};

extern struct desc_struct idt_table[],gdt_table[];
extern struct desc_struct *idt, *gdt;

struct Xgt_desc_struct {
	unsigned short size;
	unsigned long address __attribute__((packed));
};














# 64 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/fs.h" 1 3



 




# 1 "/usr/include/linux/config.h" 1 3



# 1 "/usr/include/linux/autoconf.h" 1 3
 




 




 






 



















 




 





 




 









 


























 







 












 




 







 





 





























 



























 




 




 





 






























 




 





















 




 




 




# 4 "/usr/include/linux/config.h" 2 3


 


















 





# 9 "/usr/include/linux/fs.h" 2 3


# 1 "/usr/include/linux/limits.h" 1 3



















# 11 "/usr/include/linux/fs.h" 2 3

# 1 "/usr/include/linux/wait.h" 1 3








# 31 "/usr/include/linux/wait.h" 3



# 12 "/usr/include/linux/fs.h" 2 3


# 1 "/usr/include/linux/vfs.h" 1 3



# 1 "/usr/include/asm/statfs.h" 1 3







typedef __kernel_fsid_t	fsid_t;



struct statfs {
	long f_type;
	long f_bsize;
	long f_blocks;
	long f_bfree;
	long f_bavail;
	long f_files;
	long f_ffree;
	__kernel_fsid_t f_fsid;
	long f_namelen;
	long f_spare[6];
};


# 4 "/usr/include/linux/vfs.h" 2 3



# 14 "/usr/include/linux/fs.h" 2 3

# 1 "/usr/include/linux/net.h" 1 3
 



















# 1 "/usr/include/linux/socket.h" 1 3



# 1 "/usr/include/asm/socket.h" 1 3



# 1 "/usr/include/asm/sockios.h" 1 3



 








# 4 "/usr/include/asm/socket.h" 2 3


 
















 







 







# 4 "/usr/include/linux/socket.h" 2 3

# 1 "/usr/include/linux/sockios.h" 1 3
 





















 




 






































 
		     




 




 




 




 

 





 


 


 


# 5 "/usr/include/linux/socket.h" 2 3

# 1 "/usr/include/linux/uio.h" 1 3





 









 


struct iovec
{
	void *iov_base;		 
	__kernel_size_t iov_len;  
};

 


 









# 6 "/usr/include/linux/socket.h" 2 3



typedef unsigned short	sa_family_t;

 


 
struct sockaddr {
	sa_family_t	sa_family;	 
	char		sa_data[14];	 
};

struct linger {
	int		l_onoff;	 
	int		l_linger;	 
};

 




 
struct msghdr {
	void	*	msg_name;	 
	int		msg_namelen;	 
	struct iovec *	msg_iov;	 
	__kernel_size_t	msg_iovlen;	 
	void 	*	msg_control;	 
	__kernel_size_t	msg_controllen;	 
	unsigned	msg_flags;
};

 





struct cmsghdr {
	__kernel_size_t	cmsg_len;	 
        int		cmsg_level;	 
        int		cmsg_type;	 
};

 


















 


 







 


 
static  struct cmsghdr * __cmsg_nxthdr(void *__ctl, __kernel_size_t __size,
					       struct cmsghdr *__cmsg)
{
	unsigned char * __ptr;

	if (__cmsg->cmsg_len < sizeof(struct cmsghdr))
		return ((void *) 0) ;
	__ptr = ((unsigned char *) __cmsg) +  ( (( __cmsg->cmsg_len )+sizeof(long)-1) & ~(sizeof(long)-1) ) ;
	if (__ptr >= (unsigned char *) __ctl + __size)
		return ((void *) 0) ;

	return (struct cmsghdr *) __ptr;
}

static  struct cmsghdr * cmsg_nxthdr (struct msghdr *__msg, struct cmsghdr *__cmsg)
{
	return __cmsg_nxthdr(__msg->msg_control, __msg->msg_controllen, __cmsg);
}

 





struct ucred {
	__kernel_pid_t	pid;
	__kernel_uid_t	uid;
	__kernel_gid_t	gid;
};

 







					 
					 
					 
					 

 






















 























 


 


 




















 

 














 


 



# 243 "/usr/include/linux/socket.h" 3


# 21 "/usr/include/linux/net.h" 2 3


struct poll_table_struct;























typedef enum {
  SS_FREE = 0,				 
  SS_UNCONNECTED,			 
  SS_CONNECTING,			 
  SS_CONNECTED,				 
  SS_DISCONNECTING			 
} socket_state;





# 142 "/usr/include/linux/net.h" 3


# 15 "/usr/include/linux/fs.h" 2 3

# 1 "/usr/include/linux/kdev_t.h" 1 3


# 104 "/usr/include/linux/kdev_t.h" 3


 








# 16 "/usr/include/linux/fs.h" 2 3

# 1 "/usr/include/linux/ioctl.h" 1 3



# 1 "/usr/include/asm/ioctl.h" 1 3
 







 









 






















 












 





 





 








# 4 "/usr/include/linux/ioctl.h" 2 3




# 17 "/usr/include/linux/fs.h" 2 3

# 1 "/usr/include/linux/list.h" 1 3



# 97 "/usr/include/linux/list.h" 3



# 18 "/usr/include/linux/fs.h" 2 3

# 1 "/usr/include/linux/dcache.h" 1 3



# 166 "/usr/include/linux/dcache.h" 3



# 19 "/usr/include/linux/fs.h" 2 3



# 1 "/usr/include/asm/bitops.h" 1 3



 



 













 


extern void set_bit(int nr, volatile void * addr);
extern void clear_bit(int nr, volatile void * addr);
extern void change_bit(int nr, volatile void * addr);
extern int test_and_set_bit(int nr, volatile void * addr);
extern int test_and_clear_bit(int nr, volatile void * addr);
extern int test_and_change_bit(int nr, volatile void * addr);
extern int __constant_test_bit(int nr, const volatile void * addr);
extern int __test_bit(int nr, volatile void * addr);
extern int find_first_zero_bit(void * addr, unsigned size);
extern int find_next_zero_bit (void * addr, int size, int offset);
extern unsigned long ffz(unsigned long word);

 


struct __dummy { unsigned long a[100]; };



extern __inline__ void set_bit(int nr, volatile void * addr)
{
	__asm__ __volatile__( "" 
		"btsl %1,%0"
		:"=m" ((*(volatile struct __dummy *) addr) )
		:"ir" (nr));
}

extern __inline__ void clear_bit(int nr, volatile void * addr)
{
	__asm__ __volatile__( "" 
		"btrl %1,%0"
		:"=m" ((*(volatile struct __dummy *) addr) )
		:"ir" (nr));
}

extern __inline__ void change_bit(int nr, volatile void * addr)
{
	__asm__ __volatile__( "" 
		"btcl %1,%0"
		:"=m" ((*(volatile struct __dummy *) addr) )
		:"ir" (nr));
}

extern __inline__ int test_and_set_bit(int nr, volatile void * addr)
{
	int oldbit;

	__asm__ __volatile__( "" 
		"btsl %2,%1\n\tsbbl %0,%0"
		:"=r" (oldbit),"=m" ((*(volatile struct __dummy *) addr) )
		:"ir" (nr));
	return oldbit;
}

extern __inline__ int test_and_clear_bit(int nr, volatile void * addr)
{
	int oldbit;

	__asm__ __volatile__( "" 
		"btrl %2,%1\n\tsbbl %0,%0"
		:"=r" (oldbit),"=m" ((*(volatile struct __dummy *) addr) )
		:"ir" (nr));
	return oldbit;
}

extern __inline__ int test_and_change_bit(int nr, volatile void * addr)
{
	int oldbit;

	__asm__ __volatile__( "" 
		"btcl %2,%1\n\tsbbl %0,%0"
		:"=r" (oldbit),"=m" ((*(volatile struct __dummy *) addr) )
		:"ir" (nr));
	return oldbit;
}

 


extern __inline__ int __constant_test_bit(int nr, const volatile void * addr)
{
	return ((1UL << (nr & 31)) & (((const volatile unsigned int *) addr)[nr >> 5])) != 0;
}

extern __inline__ int __test_bit(int nr, volatile void * addr)
{
	int oldbit;

	__asm__ __volatile__(
		"btl %2,%1\n\tsbbl %0,%0"
		:"=r" (oldbit)
		:"m" ((*(volatile struct __dummy *) addr) ),"ir" (nr));
	return oldbit;
}






 


extern __inline__ int find_first_zero_bit(void * addr, unsigned size)
{
	int res;

	if (!size)
		return 0;
	__asm__("cld\n\t"
		"movl $-1,%%eax\n\t"
		"xorl %%edx,%%edx\n\t"
		"repe; scasl\n\t"
		"je 1f\n\t"
		"xorl -4(%%edi),%%eax\n\t"
		"subl $4,%%edi\n\t"
		"bsfl %%eax,%%edx\n"
		"1:\tsubl %%ebx,%%edi\n\t"
		"shll $3,%%edi\n\t"
		"addl %%edi,%%edx"
		:"=d" (res)
		:"c" ((size + 31) >> 5), "D" (addr), "b" (addr)
		:"ax", "cx", "di");
	return res;
}

extern __inline__ int find_next_zero_bit (void * addr, int size, int offset)
{
	unsigned long * p = ((unsigned long *) addr) + (offset >> 5);
	int set = 0, bit = offset & 31, res;
	
	if (bit) {
		 


		__asm__("bsfl %1,%0\n\t"
			"jne 1f\n\t"
			"movl $32, %0\n"
			"1:"
			: "=r" (set)
			: "r" (~(*p >> bit)));
		if (set < (32 - bit))
			return set + offset;
		set = 32 - bit;
		p++;
	}
	 


	res = find_first_zero_bit (p, size - 32 * (p - (unsigned long *) addr));
	return (offset + set + res);
}

 



extern __inline__ unsigned long ffz(unsigned long word)
{
	__asm__("bsfl %1,%0"
		:"=r" (word)
		:"r" (~word));
	return word;
}

# 204 "/usr/include/asm/bitops.h" 3



# 22 "/usr/include/linux/fs.h" 2 3




 








 







 
extern int max_inodes;
extern int max_files, nr_files, nr_free_files;

























 







 














 




 





 

























 


















# 840 "/usr/include/linux/fs.h" 3



# 65 "/usr/include/linux/sched.h" 2 3


# 1 "/usr/include/linux/time.h" 1 3








struct timespec {
	time_t	tv_sec;		 
	long	tv_nsec;	 
};


 



static __inline__ unsigned long
timespec_to_jiffies(struct timespec *value)
{
	unsigned long sec = value->tv_sec;
	long nsec = value->tv_nsec;

	if (sec > ((long)(~0UL >> 1) / 100 ))
		return ~0UL >> 1;
	nsec += 1000000000L / 100  - 1;
	nsec /= 1000000000L / 100 ;
	return 100  * sec + nsec;
}

static __inline__ void
jiffies_to_timespec(unsigned long jiffies, struct timespec *value)
{
	value->tv_nsec = (jiffies % 100 ) * (1000000000L / 100 );
	value->tv_sec = jiffies / 100 ;
}
 
struct timeval {
	time_t		tv_sec;		 
	suseconds_t	tv_usec;	 
};

struct timezone {
	int	tz_minuteswest;	 
	int	tz_dsttime;	 
};
















 







struct  itimerspec {
        struct  timespec it_interval;     
        struct  timespec it_value;        
};

struct	itimerval {
	struct	timeval it_interval;	 
	struct	timeval it_value;	 
};


# 67 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/param.h" 1 3






# 68 "/usr/include/linux/sched.h" 2 3

# 1 "/usr/include/linux/resource.h" 1 3





 



 










struct	rusage {
	struct timeval ru_utime;	 
	struct timeval ru_stime;	 
	long	ru_maxrss;		 
	long	ru_ixrss;		 
	long	ru_idrss;		 
	long	ru_isrss;		 
	long	ru_minflt;		 
	long	ru_majflt;		 
	long	ru_nswap;		 
	long	ru_inblock;		 
	long	ru_oublock;		 
	long	ru_msgsnd;		 
	long	ru_msgrcv;		 
	long	ru_nsignals;		 
	long	ru_nvcsw;		 
	long	ru_nivcsw;		 
};



struct rlimit {
	long	rlim_cur;
	long	rlim_max;
};








 



# 1 "/usr/include/asm/resource.h" 1 3



 
















# 37 "/usr/include/asm/resource.h" 3



# 58 "/usr/include/linux/resource.h" 2 3



# 69 "/usr/include/linux/sched.h" 2 3


# 1 "/usr/include/linux/timer.h" 1 3



 




 



















































struct timer_struct {
	unsigned long expires;
	void (*fn)(void);
};

extern unsigned long timer_active;
extern struct timer_struct timer_table[32];

 












struct timer_list {
	struct timer_list *next;
	struct timer_list *prev;
	unsigned long expires;
	unsigned long data;
	void (*function)(unsigned long);
};

extern void add_timer(struct timer_list * timer);
extern int  del_timer(struct timer_list * timer);

extern void it_real_fn(unsigned long);

extern inline void init_timer(struct timer_list * timer)
{
	timer->next = ((void *) 0) ;
	timer->prev = ((void *) 0) ;
}


# 71 "/usr/include/linux/sched.h" 2 3


# 1 "/usr/include/asm/processor.h" 1 3
 








# 1 "/usr/include/asm/vm86.h" 1 3



 





























 










 





 










 





struct vm86_regs {
 


	long ebx;
	long ecx;
	long edx;
	long esi;
	long edi;
	long ebp;
	long eax;
	long __null_ds;
	long __null_es;
	long __null_fs;
	long __null_gs;
	long orig_eax;
	long eip;
	unsigned short cs, __csh;
	long eflags;
	long esp;
	unsigned short ss, __ssh;
 


	unsigned short es, __esh;
	unsigned short ds, __dsh;
	unsigned short fs, __fsh;
	unsigned short gs, __gsh;
};

struct revectored_struct {
	unsigned long __map[8];			 
};

struct vm86_struct {
	struct vm86_regs regs;
	unsigned long flags;
	unsigned long screen_bitmap;
	unsigned long cpu_type;
	struct revectored_struct int_revectored;
	struct revectored_struct int21_revectored;
};

 




struct vm86plus_info_struct {
	unsigned long force_return_for_pic:1;
	unsigned long vm86dbg_active:1;        
	unsigned long vm86dbg_TFpendig:1;      
	unsigned long unused:28;
	unsigned long is_vm86pus:1;	       
	unsigned char vm86dbg_intxxtab[32];    
};

struct vm86plus_struct {
	struct vm86_regs regs;
	unsigned long flags;
	unsigned long screen_bitmap;
	unsigned long cpu_type;
	struct revectored_struct int_revectored;
	struct revectored_struct int21_revectored;
	struct vm86plus_info_struct vm86plus;
};

# 206 "/usr/include/asm/vm86.h" 3



# 10 "/usr/include/asm/processor.h" 2 3

# 1 "/usr/include/asm/math_emu.h" 1 3



# 1 "/usr/include/asm/sigcontext.h" 1 3



 







struct _fpreg {
	unsigned short significand[4];
	unsigned short exponent;
};

struct _fpstate {
	unsigned long 	cw,
			sw,
			tag,
			ipoff,
			cssel,
			dataoff,
			datasel;
	struct _fpreg	_st[8];
	unsigned long	status;
};

struct sigcontext {
	unsigned short gs, __gsh;
	unsigned short fs, __fsh;
	unsigned short es, __esh;
	unsigned short ds, __dsh;
	unsigned long edi;
	unsigned long esi;
	unsigned long ebp;
	unsigned long esp;
	unsigned long ebx;
	unsigned long edx;
	unsigned long ecx;
	unsigned long eax;
	unsigned long trapno;
	unsigned long err;
	unsigned long eip;
	unsigned short cs, __csh;
	unsigned long eflags;
	unsigned long esp_at_signal;
	unsigned short ss, __ssh;
	struct _fpstate * fpstate;
	unsigned long oldmask;
	unsigned long cr2;
};



# 4 "/usr/include/asm/math_emu.h" 2 3


void restore_i387_soft(void *s387, struct _fpstate *buf);
struct _fpstate * save_i387_soft(void *s387, struct _fpstate * buf);

 



struct info {
	long ___orig_eip;
	long ___ret_from_system_call;
	long ___ebx;
	long ___ecx;
	long ___edx;
	long ___esi;
	long ___edi;
	long ___ebp;
	long ___eax;
	long ___ds;
	long ___es;
	long ___orig_eax;
	long ___eip;
	long ___cs;
	long ___eflags;
	long ___esp;
	long ___ss;
	long ___vm86_es;  
	long ___vm86_ds;
	long ___vm86_fs;
	long ___vm86_gs;
};

# 11 "/usr/include/asm/processor.h" 2 3



 




extern char hard_math;
extern char x86;		 
extern char x86_vendor_id[13];
extern char x86_model;		 
extern char x86_mask;		 
extern int  x86_capability;	 
extern int  fdiv_bug;		
extern char ignore_irq13;
extern char wp_works_ok;	 
extern char hlt_works_ok;	 
extern int  have_cpuid;		 

 


extern int EISA_bus;
extern int MCA_bus;

 

extern unsigned int machine_id;
extern unsigned int machine_submodel_id;
extern unsigned int BIOS_revision;

 





 




 




struct i387_hard_struct {
	long	cwd;
	long	swd;
	long	twd;
	long	fip;
	long	fcs;
	long	foo;
	long	fos;
	long	st_space[20];	 
	long	status;		 
};

struct i387_soft_struct {
	long	cwd;
	long	swd;
	long	twd;
	long	fip;
	long	fcs;
	long	foo;
	long	fos;
	long	st_space[20];	 
	unsigned char	ftop, changed, lookahead, no_update, rm, alimit;
	struct info	*info;
	unsigned long	entry_eip;
};

union i387_union {
	struct i387_hard_struct hard;
	struct i387_soft_struct soft;
};

typedef struct {
	unsigned long seg;
} mm_segment_t;

struct thread_struct {
	unsigned short	back_link,__blh;
	unsigned long	esp0;
	unsigned short	ss0,__ss0h;
	unsigned long	esp1;
	unsigned short	ss1,__ss1h;
	unsigned long	esp2;
	unsigned short	ss2,__ss2h;
	unsigned long	cr3;
	unsigned long	eip;
	unsigned long	eflags;
	unsigned long	eax,ecx,edx,ebx;
	unsigned long	esp;
	unsigned long	ebp;
	unsigned long	esi;
	unsigned long	edi;
	unsigned short	es, __esh;
	unsigned short	cs, __csh;
	unsigned short	ss, __ssh;
	unsigned short	ds, __dsh;
	unsigned short	fs, __fsh;
	unsigned short	gs, __gsh;
	unsigned short	ldt, __ldth;
	unsigned short	trace, bitmap;
	unsigned long	io_bitmap[32 +1];
	unsigned long	tr;
	unsigned long	cr2, trap_no, error_code;
	mm_segment_t	segment;
 
	union i387_union i387;
 
	struct vm86_struct * vm86_info;
	unsigned long screen_bitmap;
	unsigned long v86flags, v86mask, v86mode, saved_esp0;
};





# 149 "/usr/include/asm/processor.h" 3


# 161 "/usr/include/asm/processor.h" 3

 
extern void release_thread(struct task_struct *);

 


extern inline unsigned long thread_saved_pc(struct thread_struct *t)
{
	return ((unsigned long *)t->esp)[3];
}

 
 










# 73 "/usr/include/linux/sched.h" 2 3









 






struct sched_param {
	int sched_priority;
};





# 633 "/usr/include/linux/sched.h" 3



# 13 "/usr/include/linux/nfs_fs.h" 2 3

# 1 "/usr/include/linux/nfs.h" 1 3
 





# 1 "/usr/include/linux/sunrpc/msg_prot.h" 1 3
 








# 61 "/usr/include/linux/sunrpc/msg_prot.h" 3


# 7 "/usr/include/linux/nfs.h" 2 3



















	
enum nfs_stat {
	NFS_OK = 0,
	NFSERR_PERM = 1,
	NFSERR_NOENT = 2,
	NFSERR_IO = 5,
	NFSERR_NXIO = 6,
	NFSERR_EAGAIN = 11,
	NFSERR_ACCES = 13,
	NFSERR_EXIST = 17,
	NFSERR_NODEV = 19,
	NFSERR_NOTDIR = 20,
	NFSERR_ISDIR = 21,
	NFSERR_INVAL = 22,	 
	NFSERR_FBIG = 27,
	NFSERR_NOSPC = 28,
	NFSERR_ROFS = 30,
	NFSERR_NAMETOOLONG = 63,
	NFSERR_NOTEMPTY = 66,
	NFSERR_DQUOT = 69,
	NFSERR_STALE = 70,
	NFSERR_WFLUSH = 99
};

enum nfs_ftype {
	NFNON = 0,
	NFREG = 1,
	NFDIR = 2,
	NFBLK = 3,
	NFCHR = 4,
	NFLNK = 5,
	NFSOCK = 6,
	NFBAD = 7,
	NFFIFO = 8
};

struct nfs_fh {
	char			data[32 ];
};






















 








# 222 "/usr/include/linux/nfs.h" 3



# 14 "/usr/include/linux/nfs_fs.h" 2 3

# 1 "/usr/include/linux/in.h" 1 3
 





















 
enum {
  IPPROTO_IP = 0,		 
  IPPROTO_ICMP = 1,		 
  IPPROTO_IGMP = 2,		 
  IPPROTO_IPIP = 4,		 
  IPPROTO_TCP = 6,		 
  IPPROTO_EGP = 8,		 
  IPPROTO_PUP = 12,		 
  IPPROTO_UDP = 17,		 
  IPPROTO_IDP = 22,		 
  IPPROTO_RSVP = 46,		 
  IPPROTO_GRE = 47,		 

  IPPROTO_IPV6	 = 41,		 

  IPPROTO_PIM    = 103,		 

  IPPROTO_RAW	 = 255,		 
  IPPROTO_MAX
};


 
struct in_addr {
	__u32	s_addr;
};















 


 










 




 

struct ip_mreq 
{
	struct in_addr imr_multiaddr;	 
	struct in_addr imr_interface;	 
};

struct ip_mreqn
{
	struct in_addr	imr_multiaddr;		 
	struct in_addr	imr_address;		 
	int		imr_ifindex;		 
};

struct in_pktinfo
{
	int		ipi_ifindex;
	struct in_addr	ipi_spec_dst;
	struct in_addr	ipi_addr;
};

 

struct sockaddr_in {
  sa_family_t		sin_family;	 
  unsigned short int	sin_port;	 
  struct in_addr	sin_addr;	 

   
  unsigned char		__pad[16  - sizeof(short int) -
			sizeof(unsigned short int) - sizeof(struct in_addr)];
};



 




























 


 


 


 


 



 






 
# 1 "/usr/include/asm/byteorder.h" 1 3







 




static __inline__ __const__ __u32 ___arch__swab32(__u32 x)
{



	__asm__("xchgb %b0,%h0\n\t"	 
		"rorl $16,%0\n\t"	 
		"xchgb %b0,%h0"		 
		:"=q" (x)
		: "0" (x));

	return x;
}

static __inline__ __const__ __u16 ___arch__swab16(__u16 x)
{
	__asm__("xchgb %b0,%h0"		  		: "=q" (x) 		:  "0" (x)); 		return x;



}











# 1 "/usr/include/linux/byteorder/little_endian.h" 1 3










# 1 "/usr/include/linux/byteorder/swab.h" 1 3



 
























# 38 "/usr/include/linux/byteorder/swab.h" 3

 

































 


# 89 "/usr/include/linux/byteorder/swab.h" 3







extern __inline__ __const__ __u16 __fswab16(__u16 x)
{
	return ___arch__swab16( x ) ;
}
extern __inline__ __u16 __swab16p(__u16 *x)
{
	return __fswab16( *( x ) )  ;
}
extern __inline__ void __swab16s(__u16 *addr)
{
	do { *( addr ) = __swab16p(( addr )); } while (0) ;
}

extern __inline__ __const__ __u32 __fswab32(__u32 x)
{
	return ___arch__swab32( x ) ;
}
extern __inline__ __u32 __swab32p(__u32 *x)
{
	return __fswab32( *( x ) )  ;
}
extern __inline__ void __swab32s(__u32 *addr)
{
	do { *( addr ) = __swab32p(( addr )); } while (0) ;
}


extern __inline__ __const__ __u64 __fswab64(__u64 x)
{

	__u32 h = x >> 32;
        __u32 l = x & ((1ULL<<32)-1);
        return (((__u64)__fswab32( l ) ) << 32) | ((__u64)(__fswab32( h ) ));



}
extern __inline__ __u64 __swab64p(__u64 *x)
{
	return __fswab64( *( x ) )  ;
}
extern __inline__ void __swab64s(__u64 *addr)
{
	do { *( addr ) = __swab64p(( addr )); } while (0) ;
}


# 153 "/usr/include/linux/byteorder/swab.h" 3



# 11 "/usr/include/linux/byteorder/little_endian.h" 2 3











































# 1 "/usr/include/linux/byteorder/generic.h" 1 3



 































 








































# 118 "/usr/include/linux/byteorder/generic.h" 3



 


















 



extern unsigned long int	ntohl(unsigned long int);
extern unsigned short int	ntohs(unsigned short int);
extern unsigned long int	htonl(unsigned long int);
extern unsigned short int	htons(unsigned short int);


# 162 "/usr/include/linux/byteorder/generic.h" 3




# 54 "/usr/include/linux/byteorder/little_endian.h" 2 3



# 45 "/usr/include/asm/byteorder.h" 2 3



# 173 "/usr/include/linux/in.h" 2 3


# 183 "/usr/include/linux/in.h" 3



# 15 "/usr/include/linux/nfs_fs.h" 2 3

# 1 "/usr/include/linux/sunrpc/debug.h" 1 3
 











# 1 "/usr/include/linux/tqueue.h" 1 3
 
















# 1 "/usr/include/asm/spinlock.h" 1 3





 


typedef struct { } spinlock_t;















 









typedef struct { } rwlock_t;




















# 180 "/usr/include/asm/spinlock.h" 3


# 18 "/usr/include/linux/tqueue.h" 2 3


 






















struct tq_struct {
	struct tq_struct *next;		 
	unsigned long sync;		 
	void (*routine)(void *);	 
	void *data;			 
};

typedef struct tq_struct * task_queue;



extern task_queue tq_timer, tq_immediate, tq_scheduler, tq_disk;

 





















extern spinlock_t tqueue_lock;

 


extern __inline__ void queue_task(struct tq_struct *bh_pointer,
			   task_queue *bh_list)
{
	if (!test_and_set_bit(0,&bh_pointer->sync)) {
		unsigned long flags;
		do { __asm__ __volatile__("pushfl ; popl %0":"=g" (    flags   ):   :"memory")  ; __asm__ __volatile__ ("cli": : :"memory")  ; } while (0) ;
		bh_pointer->next = *bh_list;
		*bh_list = bh_pointer;
		__asm__ __volatile__("pushl %0 ; popfl":   :"g" (    flags   ):"memory")   ;
	}
}

 


extern __inline__ void run_task_queue(task_queue *list)
{
	struct tq_struct *p;

	p = ((__typeof__(*( list )))__xchg((unsigned long)( ((void *) 0)  ),( list ),sizeof(*( list )))) ;
	while (p) {
		void *arg;
		void (*f) (void *);
		struct tq_struct *save_p;
		arg    = p -> data;
		f      = p -> routine;
		save_p = p;
		p      = p -> next;
		save_p -> sync = 0;
		(*f)(arg);
	}
}


# 13 "/usr/include/linux/sunrpc/debug.h" 2 3


 



 

 














# 74 "/usr/include/linux/sunrpc/debug.h" 3


 







enum {
	CTL_RPCDEBUG = 1,
	CTL_NFSDEBUG,
	CTL_NFSDDEBUG,
	CTL_NLMDEBUG,
};


# 16 "/usr/include/linux/nfs_fs.h" 2 3

# 1 "/usr/include/linux/nfs_mount.h" 1 3



 







 








struct nfs_mount_data {
	int		version;		 
	int		fd;			 
	struct nfs_fh	root;			 
	int		flags;			 
	int		rsize;			 
	int		wsize;			 
	int		timeo;			 
	int		retrans;		 
	int		acregmin;		 
	int		acregmax;		 
	int		acdirmin;		 
	int		acdirmax;		 
	struct sockaddr_in addr;		 
	char		hostname[256];		 
	int		namlen;			 
	unsigned int	bsize;			 
};

 











 

# 17 "/usr/include/linux/nfs_fs.h" 2 3


 







 











 




 






 































 




# 222 "/usr/include/linux/nfs_fs.h" 3


 






















# 15 "rpcdebug.c" 2

# 1 "/usr/include/linux/nfsd/debug.h" 1 3
 












 







 


























# 16 "rpcdebug.c" 2

# 1 "/usr/include/linux/lockd/debug.h" 1 3
 










# 35 "/usr/include/linux/lockd/debug.h" 3


 














# 17 "rpcdebug.c" 2

# 1 "/usr/include/stdio.h" 1 3
 



















 









# 1 "/usr/include/features.h" 1 3
 





















 




































 









 







 



 





 








 



































 
# 1 "/usr/include/sys/cdefs.h" 1 3
 






















# 1 "/usr/include/features.h" 1 3
 

















# 136 "/usr/include/features.h" 3

# 24 "/usr/include/sys/cdefs.h" 2 3










 


 


# 50 "/usr/include/sys/cdefs.h" 3

   


















# 100 "/usr/include/sys/cdefs.h" 3








 







 

typedef long double __long_double_t;

# 128 "/usr/include/sys/cdefs.h" 3


 




 







 













# 134 "/usr/include/features.h" 2 3



# 31 "/usr/include/stdio.h" 2 3



# 1 "/usr/include/libio.h" 1 3
 























 




# 1 "/usr/include/_G_config.h" 1 3
  




















typedef long _G_clock_t;
typedef unsigned short _G_dev_t;
typedef long int _G_fpos_t;
typedef unsigned short _G_gid_t;
typedef unsigned long _G_ino_t;
typedef unsigned short _G_mode_t;
typedef unsigned short _G_nlink_t;
typedef long _G_off_t;
typedef int _G_pid_t;



typedef int _G_ptrdiff_t;
typedef unsigned long _G_sigset_t;



typedef unsigned int _G_size_t;
typedef long _G_time_t;
typedef unsigned short _G_uid_t;
typedef long int _G_wchar_t;
typedef int _G_ssize_t;
typedef int   _G_wint_t;
typedef void * _G_va_list;




typedef          int   _G_int8_t __attribute__((__mode__(__QI__)));
typedef unsigned int  _G_uint8_t __attribute__((__mode__(__QI__)));
typedef          int  _G_int16_t __attribute__((__mode__(__HI__)));
typedef unsigned int _G_uint16_t __attribute__((__mode__(__HI__)));
typedef          int  _G_int32_t __attribute__((__mode__(__SI__)));
typedef unsigned int _G_uint32_t __attribute__((__mode__(__SI__)));
typedef          int  _G_int64_t __attribute__((__mode__(__DI__)));
typedef unsigned int _G_uint64_t __attribute__((__mode__(__DI__)));








































# 30 "/usr/include/libio.h" 2 3













# 51 "/usr/include/libio.h" 3


# 63 "/usr/include/libio.h" 3


 







































 























 

















 


struct _IO_lock_t {
  void *ptr;
  short int field1;
  short int field2;
};

 

struct _IO_jump_t;  struct _IO_FILE;

struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
   

   
  int _pos;
# 176 "/usr/include/libio.h" 3

};



struct _IO_FILE {







  int _flags;		 
   
  char* _IO_read_ptr;	 
  char* _IO_read_end;	 
  char* _IO_read_base;	 

  char* _IO_write_base;	 
  char* _IO_write_ptr;	 
  char* _IO_write_end;	 
  char* _IO_buf_base;	 
  char* _IO_buf_end;	 
   
  char *_IO_save_base;  
  char *_IO_backup_base;   
  char *_IO_save_end;  

  struct _IO_marker *_markers;
  
  struct _IO_FILE *_chain;
  
  int _fileno;
  int _blksize;
  _G_off_t  _offset;
  

   
  unsigned short _cur_column;
  char _unused;
  char _shortbuf[1];
  
   

  struct _IO_lock_t _IO_lock;
};


typedef struct _IO_FILE _IO_FILE;


struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_stdin_, _IO_stdout_, _IO_stderr_;








extern int __underflow  (_IO_FILE*)  ;
extern int __uflow  (_IO_FILE*)  ;
extern int __overflow  (_IO_FILE*, int)  ;

















 



extern int _IO_vfscanf  (_IO_FILE*, const char*, _G_va_list , int*)  ;
extern int _IO_vfprintf  (_IO_FILE*, const char*, _G_va_list )  ;
extern _G_ssize_t  _IO_padn  (_IO_FILE *, int, _G_ssize_t )  ;
extern _G_size_t  _IO_sgetn  (_IO_FILE *, void*, _G_size_t )  ;

extern _G_fpos_t  _IO_seekoff  (_IO_FILE*, _G_off_t , int, int)  ;
extern _G_fpos_t  _IO_seekpos  (_IO_FILE*, _G_fpos_t , int)  ;

extern void _IO_free_backup_area  (_IO_FILE*)  ;






# 34 "/usr/include/stdio.h" 2 3

























  
# 74 "/usr/include/stdio.h" 3


typedef struct _IO_FILE FILE;
typedef _G_fpos_t  fpos_t;




 








 

extern FILE *stdin, *stdout, *stderr;

# 104 "/usr/include/stdio.h" 3








 

extern void clearerr  (FILE*)  ;
extern int fclose  (FILE*)  ;
extern int feof  (FILE*)  ;
extern int ferror  (FILE*)  ;
extern int fflush  (FILE*)  ;
extern int fgetc  (FILE *)  ;
extern int fgetpos  (FILE* fp, fpos_t *pos)  ;
extern char* fgets  (char*, int, FILE*)  ;
extern FILE* fopen  (__const char*, __const char*)  ;
extern int fprintf  (FILE*, __const char* format, ...)  ;
extern int fputc  (int, FILE*)  ;
extern int fputs  (__const char *str, FILE *fp)  ;
extern size_t fread  (void*, size_t, size_t, FILE*)  ;
extern FILE* freopen  (__const char*, __const char*, FILE*)  ;
extern int fscanf  (FILE *fp, __const char* format, ...)  ;
extern int fseek  (FILE* fp, long int offset, int whence)  ;
extern int fsetpos  (FILE* fp, __const fpos_t *pos)  ;
extern long int ftell  (FILE* fp)  ;
extern size_t fwrite  (__const void*, size_t, size_t, FILE*)  ;
extern int getc  (FILE *)  ;
extern int getchar  (void)  ;
extern char* gets  (char*)  ;
extern void perror  (__const char *)  ;
extern int printf  (__const char* format, ...)  ;
extern int putc  (int, FILE *)  ;
extern int putchar  (int)  ;
extern int puts  (__const char *str)  ;
extern int remove  (__const char*)  ;
extern int rename  (__const char* _old, __const char* _new)  ;
extern void rewind  (FILE*)  ;
extern int scanf  (__const char* format, ...)  ;
extern void setbuf  (FILE*, char*)  ;
extern void setlinebuf  (FILE*)  ;
extern void setbuffer  (FILE*, char*, int)  ;
extern int setvbuf  (FILE*, char*, int mode, size_t size)  ;
extern int sprintf  (char*, __const char* format, ...)  ;
extern int sscanf  (__const char* string, __const char* format, ...)  ;
extern FILE* tmpfile  (void)  ;
extern char* tmpnam  (char*)  ;
extern int ungetc  (int c, FILE* fp)  ;
extern int vfprintf  (FILE *fp, char __const *fmt0, _G_va_list)  ;
extern int vprintf  (char __const *fmt, _G_va_list)  ;
extern int vsprintf  (char* string, __const char* format, _G_va_list)  ;


extern int vfscanf  (FILE*, __const char *, _G_va_list)  ;
extern int vscanf  (__const char *, _G_va_list)  ;
extern int vsscanf  (__const char *, __const char *, _G_va_list)  ;

extern int getw  (FILE*)  ;
extern int putw  (int, FILE*)  ;

extern char* tempnam  (__const char *__dir, __const char *__pfx)  ;





extern int sys_nerr;
extern char *sys_errlist[];


extern int _sys_nerr;
extern char *_sys_errlist[];

 

 
extern void psignal  (int __sig, __const char *__s)  ;







extern _G_ssize_t  getdelim  (char **, size_t *, int, FILE*)  ;





extern int snprintf  (char *, size_t, const char *, ...)  ;
extern int vsnprintf  (char *, size_t, const char *, _G_va_list)  ;

extern int asprintf  (char **, const char *, ...)  ;
extern int vasprintf  (char **, const char *, _G_va_list)  ;



extern FILE *fdopen  (int, __const char *)  ;
extern int fileno  (FILE*)  ;
extern FILE* popen  (__const char*, __const char*)  ;
extern int pclose  (FILE*)  ;


extern int __underflow  (struct _IO_FILE*)  ;
extern int __overflow  (struct _IO_FILE*, int)  ;

# 226 "/usr/include/stdio.h" 3











 


# 18 "rpcdebug.c" 2

# 1 "/usr/include/stdlib.h" 1 3
 

















 



 






 



# 1 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 1 3





 


# 18 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3



 


 





 


# 60 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 





 


















 





 

 

# 130 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

 


# 181 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3





 




 



























 






















typedef long int wchar_t;
















# 269 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

# 301 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3




 



















# 34 "/usr/include/stdlib.h" 2 3


 





# 1 "/usr/include/errno.h" 1 3
 

















 







# 1 "/usr/include/linux/errno.h" 1 3



# 1 "/usr/include/asm/errno.h" 1 3




































































































































# 4 "/usr/include/linux/errno.h" 2 3


# 14 "/usr/include/linux/errno.h" 3



# 27 "/usr/include/errno.h" 2 3



extern int sys_nerr;
extern char *sys_errlist[];


extern int _sys_nerr;
extern char *_sys_errlist[];


 

extern void	perror  (__const char* __s)  ;
extern char*	strerror  (int __errno)  ;





extern int errno;






 


# 42 "/usr/include/stdlib.h" 2 3


 

 
typedef struct
  {
    int quot;			 
    int rem;			 
  } div_t;

 
typedef struct
  {
    long int quot;		 
    long int rem;		 
  } ldiv_t;


 





 





 




 
extern double atof  (__const char *__nptr)  ;
 
extern int atoi  (__const char *__nptr)  ;
 
extern long int atol  (__const char *__nptr)  ;

 
extern long long int atoq  (__const char *__nptr)  ;


 
extern float strtof  (__const char *__nptr, char **__endptr)  ;
 
extern double strtod  (__const char *__nptr, char **__endptr)  ;

 
extern __long_double_t strtold  (__const char *__nptr, char **__endptr)  ;

 
extern long int strtol  (__const char *__nptr, char **__endptr,
			     int __base)  ;
 
extern unsigned long int strtoul  (__const char *__nptr,
				       char **__endptr, int __base)  ;

 
extern long long int strtoq  (__const char *__nptr, char **__endptr,
				int __base)  ;
 
extern unsigned long long int strtouq  (__const char *__nptr,
					char **__endptr, int __base)  ;


 


extern double __strtod_internal (__const char *__nptr,
				 char **__endptr, int __group);
extern float __strtof_internal (__const char *__nptr, char **__endptr,
				int __group);
extern __long_double_t __strtold_internal (__const char *__nptr,
					   char **__endptr, int __group);
extern long int __strtol_internal (__const char *__nptr, char **__endptr,
				   int __base, int __group);
extern unsigned long int __strtoul_internal (__const char *__nptr,
					     char **__endptr, int __base,
					     int __group);

extern long long int __strtoq_internal (__const char *__nptr, char **__endptr,
					int __base, int __group);
extern unsigned long long int __strtouq_internal (__const char *__nptr,
						  char **__endptr, int __base,
						  int __group);


# 170 "/usr/include/stdlib.h" 3



 
extern int rand  (void)  ;
 
extern void srand  (unsigned int __seed)  ;

 



 
extern long int __random  (void)  ;
 
extern void __srandom  (unsigned int __seed)  ;

 



extern void *  __initstate  (unsigned int __seed, void *  __statebuf,
				 size_t __statelen)  ;
 

extern void *  __setstate  (void *  __statebuf)  ;


extern long int random  (void)  ;
extern void srandom  (unsigned int __seed)  ;
extern void *  initstate  (unsigned int __seed, void *  __statebuf,
			       size_t __statelen)  ;
extern void *  setstate  (void *  __statebuf)  ;

# 214 "/usr/include/stdlib.h" 3




 
extern void *  malloc  (size_t __size)  ;
 

extern void *  realloc  (void *  __ptr, size_t __size)  ;
 
extern void *  calloc  (size_t __nmemb, size_t __size)  ;
 
extern void free  (void *  __ptr)  ;


 
extern void cfree  (void *  __ptr)  ;



# 1 "/usr/include/alloca.h" 1 3
 






















# 1 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 1 3





 


# 18 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3



 


 





 


# 60 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 





 


















 





 

 

# 130 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

 


# 181 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3





 




 

# 257 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


# 269 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

# 301 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3




 



















# 24 "/usr/include/alloca.h" 2 3


 

 



 
extern void *  __alloca  (size_t __size)  ;

 










 


# 234 "/usr/include/stdlib.h" 2 3




 
extern void *  valloc  (size_t __size)  ;



 
extern   void abort  (void)  ;


 
extern int atexit  (void (*__func) (void))  ;


 

extern int on_exit  (void (*__func) (int __status, void *  __arg),
			 void *  __arg)  ;


 


extern   void exit  (int __status)  ;


 
extern char *getenv  (__const char *__name)  ;


 
 

extern int putenv  (__const char *__string)  ;



 

extern int setenv  (__const char *__name, __const char *__value,
			int __replace)  ;


 
extern int system  (__const char *__command)  ;




 
typedef int (*__compar_fn_t)  (__const void * , __const void * )  ;



typedef __compar_fn_t comparison_fn_t;


 

extern void *  bsearch  (__const void *  __key, __const void *  __base,
			     size_t __nmemb, size_t __size,
			     __compar_fn_t __compar)  ;

 

extern void qsort  (void *  __base, size_t __nmemb, size_t __size,
			__compar_fn_t __compar)  ;


# 314 "/usr/include/stdlib.h" 3


 
extern   int abs  (int __x)  ;
extern   long int labs  (long int __x)  ;


 

 
extern   div_t div  (int __numer, int __denom)  ;
extern   ldiv_t ldiv  (long int __numer, long int __denom)  ;


 

extern int mblen  (__const char *__s, size_t __n)  ;
 

extern int mbtowc  (wchar_t * __pwc, __const char *__s, size_t __n)  ;
 

extern int wctomb  (char *__s, wchar_t __wchar)  ;







 
extern size_t mbstowcs  (wchar_t * __pwcs, __const char *__s, size_t __n)  ;
 
extern size_t wcstombs  (char *__s, __const wchar_t * __pwcs, size_t __n)  ;

 




 





 
# 375 "/usr/include/stdlib.h" 3


 


extern char **environ;
extern char **__environ;

extern char*	ecvt  (double __value, size_t __ndigit, int *__decpt,
			int *__sign)  ;
extern char*	fcvt  (double __value, size_t __ndigit, int *__decpt,
			int *__sign)  ;
extern char*	gcvt  (double __value, size_t __ndigit, char *__buf)  ;

extern double	drand48  (void)  ;
extern double	erand48  (unsigned short int __xsubi[3])  ;
extern long int	lrand48  (void)  ;
extern long int	nrand48  (unsigned short int __xsubi[3])  ;
extern long int	mrand48  (void)  ;
extern long int	jrand48  (unsigned short int __xsubi[3])  ;
extern void	srand48  (long int __seedval)  ;
extern unsigned short int
			*seed48  (unsigned short int __seed16v[3])  ;
extern void	lcong48  (unsigned short int __param[7])  ;

extern int	setenv  (__const char *__name, __const char *__value,
			int __overwrite)  ;
extern void	unsetenv  (__const char *__name)  ;

struct qelem {
  struct qelem *q_forw;
  struct qelem *q_back;
  char q_data[1];
};

extern void insque  (struct qelem *__elem, struct qelem *__prev)  ;
extern void remque  (struct qelem *__elem)  ;



 


# 19 "rpcdebug.c" 2

# 1 "/usr/include/getopt.h" 1 3
 


























 





extern char *optarg;

 











extern int optind;

 


extern int opterr;

 

extern int optopt;

 




















struct option
{

  const char *name;



   

  int has_arg;
  int *flag;
  int val;
};

 







 


extern int getopt (int argc, char *const *argv, const char *shortopts);



extern int getopt_long (int argc, char *const *argv, const char *shortopts,
		        const struct option *longopts, int *longind);
extern int getopt_long_only (int argc, char *const *argv,
			     const char *shortopts,
		             const struct option *longopts, int *longind);

 
extern int _getopt_internal (int argc, char *const *argv,
			     const char *shortopts,
		             const struct option *longopts, int *longind,
			     int long_only);













# 20 "rpcdebug.c" 2

# 1 "/usr/include/unistd.h" 1 3
 

















 








 

 


 


 




 



 



 



 




 


























# 1 "/usr/include/posix_opt.h" 1 3



 


 


 




 



























 









# 85 "/usr/include/unistd.h" 2 3



 





 

# 1 "/usr/include/gnu/types.h" 1 3
 






















 
typedef unsigned char __u_char;
typedef unsigned short __u_short;
typedef unsigned int __u_int;
typedef unsigned long __u_long;
typedef struct
{
  long val[2];
} __quad;
typedef struct
{
  __u_long val[2];
} __u_quad;


typedef unsigned short __dev_t;	 
typedef unsigned short __gid_t;	 
typedef unsigned short __uid_t;	 
typedef unsigned short __mode_t; 
typedef long	__daddr_t;	 
typedef long	__off_t;	 
typedef long long __loff_t;	 
typedef unsigned long __ino_t;	 
typedef unsigned short __nlink_t;	 
typedef long	__time_t;
# 59 "/usr/include/gnu/types.h" 3


typedef int __pid_t;		 
typedef int __ssize_t;		 
typedef __quad __fsid_t;	 

 
typedef char *__caddr_t;
typedef long int __swblk_t;	 


 







typedef struct __fd_set {
        unsigned long fds_bits [(1024 / (8 * sizeof(unsigned long)) ) ];
} __fd_set;


# 110 "/usr/include/gnu/types.h" 3


# 134 "/usr/include/gnu/types.h" 3



# 96 "/usr/include/unistd.h" 2 3








# 1 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 1 3





 


# 18 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3



 


 





 


# 60 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 





 


















 





 

 

# 130 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

 


# 181 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3





 




 

# 257 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


# 269 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

# 301 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3




 



















# 104 "/usr/include/unistd.h" 2 3



 






 
extern int __access  (__const char *__name, int __type)  ;
extern int access  (__const char *__name, int __type)  ;


 






 




extern __off_t __lseek  (int __fd, __off_t __offset, int __whence)  ;
extern __off_t lseek  (int __fd, __off_t __offset, int __whence)  ;


 
extern __loff_t __llseek  (int __fd, __loff_t __offset, int __whence)  ;
extern __loff_t llseek  (int __fd, __loff_t __offset, int __whence)  ;


 
extern int __close  (int __fd)  ;
extern int close  (int __fd)  ;

 

extern ssize_t __read  (int __fd, void *  __buf, size_t __nbytes)  ;
extern ssize_t read  (int __fd, void *  __buf, size_t __nbytes)  ;

 
extern ssize_t __write  (int __fd, __const void *  __buf, size_t __n)  ;
extern ssize_t write  (int __fd, __const void *  __buf, size_t __n)  ;


 



extern int __pipe  (int __pipedes[2])  ;
extern int pipe  (int __pipedes[2])  ;

 






extern unsigned int alarm  (unsigned int __seconds)  ;

 






extern unsigned int sleep  (unsigned int __seconds)  ;


 

extern int pause  (void)  ;


 
extern int __chown  (__const char *__file,
			 __uid_t __owner, __gid_t __group)  ;
extern int chown  (__const char *__file,
		       __uid_t __owner, __gid_t __group)  ;


 
extern int __fchown  (int __fd,
			  __uid_t __owner, __gid_t __group)  ;
extern int fchown  (int __fd,
			__uid_t __owner, __gid_t __group)  ;
 

extern int __fchdir  (int __fd)  ;
extern int fchdir  (int __fd)  ;


 
extern int __chdir  (__const char *__path)  ;
extern int chdir  (__const char *__path)  ;

 






extern char *getcwd  (char *__buf, size_t __size)  ;


 


extern char *get_current_dir_name  (void)  ;



 


extern char *getwd  (char __buf [])  ;



 
extern int __dup  (int __fd)  ;
extern int dup  (int __fd)  ;

 
extern int __dup2  (int __fd, int __fd2)  ;
extern int dup2  (int __fd, int __fd2)  ;

 
extern char **__environ;
extern char **environ;


 

extern int __execve  (__const char *__path, char *__const __argv[],
			  char *__const __envp[])  ;
extern int execve  (__const char *__path, char *__const __argv[],
			char *__const __envp[])  ;

 
extern int execv  (__const char *__path, char *__const __argv[])  ;

 

extern int execle  (__const char *__path, __const char *__arg,...)  ;

 

extern int execl  (__const char *__path, __const char *__arg,...)  ;

 

extern int execvp  (__const char *__file, char *__const __argv[])  ;

 


extern int execlp  (__const char *__file, __const char *arg,...)  ;


 
extern   void _exit  (int __status)   __attribute__ ((noreturn)) ;


 



# 1 "/usr/include/confname.h" 1 3
 





















 
enum
  {
    _PC_LINK_MAX



    ,
    _PC_MAX_CANON,
    _PC_MAX_INPUT,
    _PC_NAME_MAX,
    _PC_PATH_MAX,
    _PC_PIPE_BUF,

    _PC_CHOWN_RESTRICTED,

    _PC_NO_TRUNC,
    _PC_VDISABLE,




     
    _PC_ASYNC_IO,
    _PC_PRIO_IO,
    _PC_SYNC_IO
  };

 
enum
  {
    _SC_ARG_MAX



    ,
    _SC_CHILD_MAX,
    _SC_CLK_TCK,
    _SC_NGROUPS_MAX,
    _SC_OPEN_MAX,


    _SC_STREAM_MAX,
    _SC_TZNAME_MAX,

    _SC_JOB_CONTROL,
    _SC_SAVED_IDS,
    _SC_VERSION,




    _SC_PAGESIZE,





     

    _SC_BC_BASE_MAX,
    _SC_BC_DIM_MAX,
    _SC_BC_SCALE_MAX,
    _SC_BC_STRING_MAX,
    _SC_COLL_WEIGHTS_MAX,
    _SC_EQUIV_CLASS_MAX,
    _SC_EXPR_NEST_MAX,
    _SC_LINE_MAX,
    _SC_RE_DUP_MAX,

    _SC_2_VERSION,
    _SC_2_C_BIND,
    _SC_2_C_DEV,
    _SC_2_FORT_DEV,
    _SC_2_FORT_RUN,
    _SC_2_SW_DEV,
    _SC_2_LOCALEDEF,

     
    _SC_AIO_LISTIO_MAX,
    _SC_AIO_MAX,
    _SC_AIO_PRIO_DELTA_MAX,
    _SC_DELAYTIMER_MAX,
    _SC_MQ_OPEN_MAX,
    _SC_MQ_PRIO_MAX,
    _SC_RTSIG_MAX,
    _SC_SEM_NSEMS_MAX,
    _SC_SEM_VALUE_MAX,
    _SC_SIGQUEUE_MAX,
    _SC_TIMER_MAX,
    _SC_ASYNCHRONOUS_IO,
    _SC_FSYNC,
    _SC_MAPPED_FILES,
    _SC_MEMLOCK,
    _SC_MEMLOCK_RANGE,
    _SC_MEMORY_PROTECTION,
    _SC_MESSAGE_PASSING,
    _SC_PRIORITIZED_IO,
    _SC_PRIORITY_SCHEDULING,
    _SC_REALTIME_SIGNALS,
    _SC_SEMAPHORES,
    _SC_SHARED_MEMORY_OBJECTS,
    _SC_SYNCHRONIZED_IO,
    _SC_TIMERS
  };


 
enum
  {
    _CS_PATH			 
  };



# 280 "/usr/include/unistd.h" 2 3


 
extern long int __pathconf  (__const char *__path, int __name)  ;
extern long int pathconf  (__const char *__path, int __name)  ;

 
extern long int __fpathconf  (int __fd, int __name)  ;
extern long int fpathconf  (int __fd, int __name)  ;


 
extern long int __sysconf  (int __name)  ;
extern long int sysconf  (int __name)  ;


 
extern size_t confstr  (int __name, char *__buf, size_t __len)  ;



 
extern __pid_t __getpid  (void)  ;
extern __pid_t getpid  (void)  ;

 
extern __pid_t __getppid  (void)  ;
extern __pid_t getppid  (void)  ;



 


extern __pid_t getpgid  (__pid_t __pid)  ;

 
extern __pid_t getpgrp  (void)  ;

 


extern int setpgid  (__pid_t __pid, __pid_t __pgid)  ;

extern int setpgrp  (void)  ;

# 350 "/usr/include/unistd.h" 3


 


extern __pid_t __setsid  (void)  ;
extern __pid_t setsid  (void)  ;

extern __pid_t __getsid  (__pid_t __pid)  ;
extern __pid_t getsid  (__pid_t __pid)  ;

 
extern __uid_t __getuid  (void)  ;
extern __uid_t getuid  (void)  ;

 
extern __uid_t __geteuid  (void)  ;
extern __uid_t geteuid  (void)  ;

 
extern __gid_t __getgid  (void)  ;
extern __gid_t getgid  (void)  ;

 
extern __gid_t __getegid  (void)  ;
extern __gid_t getegid  (void)  ;

 


extern int __getgroups  (int __size, __gid_t __list[])  ;
extern int getgroups  (int __size, __gid_t __list[])  ;

 



extern int __setuid  (__uid_t __uid)  ;
extern int setuid  (__uid_t __uid)  ;


 

extern int __setreuid  (__uid_t __ruid, __uid_t __euid)  ;
extern int setreuid  (__uid_t __ruid, __uid_t __euid)  ;

 
extern int seteuid  (__uid_t __uid)  ;


 



extern int __setgid  (__gid_t __gid)  ;
extern int setgid  (__gid_t __gid)  ;


 

extern int __setregid  (__gid_t __rgid, __gid_t __egid)  ;
extern int setregid  (__gid_t __rgid, __gid_t __egid)  ;

 
extern int setegid  (__uid_t __uid)  ;


 
extern int __setfsuid  (__uid_t __uid)  ;
extern int setfsuid  (__uid_t __uid)  ;

 
extern int __setfsgid  (__gid_t __gid)  ;
extern int setfsgid  (__gid_t __gid)  ;


 


extern __pid_t __fork  (void)  ;
extern __pid_t fork  (void)  ;


 



extern __pid_t __vfork  (void)  ;
extern __pid_t vfork  (void)  ;



 
extern char *cuserid  (char * __buf)  ;

 
extern char *ctermid  (char *__buf)  ;

 

extern char *ttyname  (int __fd)  ;

 

extern int __isatty  (int __fd)  ;
extern int isatty  (int __fd)  ;


 
extern int __link  (__const char *__from, __const char *__to)  ;
extern int link  (__const char *__from, __const char *__to)  ;


 
extern int __symlink  (__const char *__from, __const char *__to)  ;
extern int symlink  (__const char *__from, __const char *__to)  ;

 


extern int __readlink  (__const char *__path, char *__buf, size_t __len)  ;
extern int readlink  (__const char *__path, char *__buf, size_t __len)  ;



 
extern int __unlink  (__const char *__name)  ;
extern int unlink  (__const char *__name)  ;

 
extern int __rmdir  (__const char *__path)  ;
extern int rmdir  (__const char *__path)  ;


 
extern __pid_t tcgetpgrp  (int __fd)  ;

 
extern int tcsetpgrp  (int __fd, __pid_t __pgrp_id)  ;


 
extern char *getlogin  (void)  ;


 
extern int setlogin  (__const char *__name)  ;



 
























extern int getopt  (int __argc, char *__const * __argv,
			__const char *__opts)  ;
extern int opterr;
extern int optind;
extern int optopt;
extern char *optarg;





 


extern int __gethostname  (char *__name, size_t __len)  ;
extern int gethostname  (char *__name, size_t __len)  ;

 

extern int sethostname  (__const char *__name, size_t __len)  ;

 
extern long int gethostid  (void)  ;

 

extern int sethostid  (long int __id)  ;


 

extern size_t __getpagesize  (void)  ;
extern size_t getpagesize  (void)  ;


 

extern int __getdtablesize  (void)  ;
extern int getdtablesize  (void)  ;

 

extern int fdatasync  (int __fd)  ;

 
extern int fsync  (int __fd)  ;

 
extern int sync  (void)  ;


 


extern int vhangup  (void)  ;


 


extern int acct  (__const char *__name)  ;

 

extern int chroot  (__const char *__path)  ;

 

extern int swapon  (__const char *__path)  ;

 
extern char *getusershell  (void)  ;
extern void endusershell  (void)  ;  
extern void setusershell  (void)  ;  

 

extern char *getpass  (__const char *__prompt)  ;




 



 








extern int lockf  (int __fd, int __cmd, __off_t __len)  ;




 


extern int	__brk  (void* __end_data_segment)  ;
extern int	brk  (void* __end_data_segment)  ;
extern void*	__sbrk  (ptrdiff_t __increment)  ;
extern void*	sbrk  (ptrdiff_t __increment)  ;

extern char*	crypt  (__const char *__key, __const char *__salt)  ;
extern void	encrypt  (char __block[64], int __edflag)  ;
extern void	setkey  (__const char *__key)  ;

extern int	ftruncate  (int __fildes, size_t __length)  ;
extern int	truncate  (__const char *__path, size_t __length)  ;

extern int	ioperm   (unsigned long __from,
			unsigned long __num, int __turn_on)  ;
extern int	iopl  (int __level)  ;

extern char*	mktemp  (char *__template)  ;
extern int	mkstemp  (char *__template)  ;

extern int	nice  (int __val)  ;

extern int	profil  (char *__buf, int __bufsiz, int __offset,
			int __scale)  ;

extern void	usleep  (unsigned long __usec)  ;



extern int	_xustat  (int __ver, dev_t __dev, struct ustat* __ubuf)  ;
static __inline__ int
ustat (dev_t __dev, struct ustat* __ubuf)
{
  return _xustat (1 , __dev, __ubuf);
}

extern int	idle  (void)  ;
extern int	reboot  (int __magic, int __magic_too,
			int __flag)  ;

extern int	swapoff  (__const char * __specialfile)  ;

extern int	uselib  (__const char *__filename)  ;

extern int	getdomainname  (char *__name, size_t __len)  ;
extern int	setdomainname  (__const char *__name, size_t __len)  ;
extern char*	realpath  (__const char *__path,
			char __resolved_path [])  ;












 


# 21 "rpcdebug.c" 2

# 1 "/usr/include/string.h" 1 3
 

















 








 

 


# 1 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 1 3





 


# 18 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3



 


 





 


# 60 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 





 


















 





 

 

# 130 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

 


# 181 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3





 




 

# 257 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


# 269 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3


 

# 301 "/usr/lib/gcc-lib/i386-linux/2.7.2.1/include/stddef.h" 3




 



















# 33 "/usr/include/string.h" 2 3


 






 

extern void *  memmove  (void *  __dest, __const void *  __src,
			     size_t __n)  ;

 


extern void *  __memccpy  (void *  __dest, __const void *  __src,
			       int __c, size_t __n)  ;

extern void *  memccpy  (void *  __dest, __const void *  __src,
			     int __c, size_t __n)  ;



 
extern void *  memset  (void *  __s, int __c, size_t __n)  ;

 






 
extern void *  memchr  (__const void *  __s, int __c, size_t __n)  ;


 
extern char *strcpy  (char *__dest, __const char *__src)  ;
 
extern char *strncpy  (char *__dest, __const char *__src, size_t __n)  ;

 
extern char *strcat  (char *__dest, __const char *__src)  ;
 
extern char *strncat  (char *__dest, __const char *__src, size_t __n)  ;

 
extern int strcmp  (__const char *__s1, __const char *__s2)  ;
 
extern int strncmp  (__const char *__s1, __const char *__s2, size_t __n)  ;

 
extern int strcoll  (__const char *__s1, __const char *__s2)  ;
 
extern size_t strxfrm  (char *__dest, __const char *__src, size_t __n)  ;


 
extern char *strdup  (__const char *__s)  ;


 
extern char *strchr  (__const char *__s, int __c)  ;
 
extern char *strrchr  (__const char *__s, int __c)  ;

 

extern size_t strcspn  (__const char *__s, __const char *__reject)  ;
 

extern size_t strspn  (__const char *__s, __const char *__accept)  ;
 
extern char *strpbrk  (__const char *__s, __const char *__accept)  ;
 
extern char *strstr  (__const char *__haystack, __const char *__needle)  ;
 
extern char *strtok  (char *__s, __const char *__delim)  ;


 


extern void *  memmem  (__const void *  __haystack,
			    size_t __haystacklen,
			    __const void *  __needle,
			    size_t __needlelen)  ;


 
extern size_t strlen  (__const char *__s)  ;

 
extern char *strerror  (int __errnum)  ;


 
extern char *index  (__const char *__s, int __c)  ;

 
extern char *rindex  (__const char *__s, int __c)  ;

# 149 "/usr/include/string.h" 3


 
extern void bcopy  (__const void *  __src, void *  __dest, int __n)  ;

 
extern void bzero  (void *  __s, int __n)  ;

 
extern int bcmp  (__const void *  __s1, __const void *  __s2, int __n)  ;



 

extern int ffs  (int __i)  ;

 
extern int strcasecmp  (__const char *__s1, __const char *__s2)  ;

 

extern char *strsep  (char **__stringp, __const char *__delim)  ;



 
extern int strncasecmp  (__const char *__s1, __const char *__s2,
			     size_t __n)  ;

 
extern char *strsignal  (int __sig)  ;

 
extern char *stpcpy  (char *__dest, __const char *__src)  ;

 

extern char *__stpncpy  (char *__dest, __const char *__src, size_t __n)  ;
extern char *stpncpy  (char *__dest, __const char *__src, size_t __n)  ;

 
extern char *strfry  (char *__string)  ;

 
extern void *  memfrob  (void *  __s, size_t __n)  ;

extern void swab  (__const void *  __from, void *  __to,
                        size_t __nbytes)  ;


 


# 22 "rpcdebug.c" 2

# 1 "/usr/include/fcntl.h" 1 3
 

















 









# 1 "/usr/include/linux/fcntl.h" 1 3



# 1 "/usr/include/asm/fcntl.h" 1 3



 



























 


 




 



 






struct flock {
	short l_type;
	short l_whence;
	off_t l_start;
	off_t l_len;
	pid_t l_pid;
};


# 4 "/usr/include/linux/fcntl.h" 2 3



# 29 "/usr/include/fcntl.h" 2 3






 

 


extern int creat  (__const char * __filename, mode_t __mode)  ;

 

extern int fcntl  (int __fildes,int __cmd, ...)  ;
extern int __fcntl  (int __fildes,int __cmd, ...)  ;

 


extern int open  (__const char * __filename, int __flags, ...)  ;
extern int __open  (__const char * __filename, int __flags, ...)  ;

# 68 "/usr/include/fcntl.h" 3


 


# 23 "rpcdebug.c" 2

# 1 "/usr/include/ctype.h" 1 3
 

















 








 




 

 







# 1 "/usr/include/endian.h" 1 3
 





















 









 
# 1 "/usr/include/bytesex.h" 1 3
















# 34 "/usr/include/endian.h" 2 3

























# 43 "/usr/include/ctype.h" 2 3







enum
{
  _ISupper = ( 0  < 8 ? ((1 <<  0 ) << 8) : ((1 <<  0 ) >> 8)) ,	 
  _ISlower = ( 1  < 8 ? ((1 <<  1 ) << 8) : ((1 <<  1 ) >> 8)) ,	 
  _ISalpha = ( 2  < 8 ? ((1 <<  2 ) << 8) : ((1 <<  2 ) >> 8)) ,	 
  _ISdigit = ( 3  < 8 ? ((1 <<  3 ) << 8) : ((1 <<  3 ) >> 8)) ,	 
  _ISxdigit = ( 4  < 8 ? ((1 <<  4 ) << 8) : ((1 <<  4 ) >> 8)) ,	 
  _ISspace = ( 5  < 8 ? ((1 <<  5 ) << 8) : ((1 <<  5 ) >> 8)) ,	 
  _ISprint = ( 6  < 8 ? ((1 <<  6 ) << 8) : ((1 <<  6 ) >> 8)) ,	 
  _ISgraph = ( 7  < 8 ? ((1 <<  7 ) << 8) : ((1 <<  7 ) >> 8)) ,	 
  _ISblank = ( 8  < 8 ? ((1 <<  8 ) << 8) : ((1 <<  8 ) >> 8)) ,	 
  _IScntrl = ( 9  < 8 ? ((1 <<  9 ) << 8) : ((1 <<  9 ) >> 8)) ,	 
  _ISpunct = ( 10  < 8 ? ((1 <<  10 ) << 8) : ((1 <<  10 ) >> 8)) ,	 

   

  _ISalnum = _ISalpha | _ISdigit	 
};

 









extern __const unsigned short int *__ctype_b;	 
extern __const int *__ctype_tolower;  
extern __const int *__ctype_toupper;  

















 



extern int  isalnum   (int)   ;
extern int  isalpha   (int)   ;
extern int  iscntrl   (int)   ;
extern int  isdigit   (int)   ;
extern int  islower   (int)   ;
extern int  isgraph   (int)   ;
extern int  isprint   (int)   ;
extern int  ispunct   (int)   ;
extern int  isspace   (int)   ;
extern int  isupper   (int)   ;
extern int  isxdigit   (int)   ;


extern int  isblank   (int)   ;



 
extern int tolower  (int __c)  ;

 
extern int toupper  (int __c)  ;




 

extern int isascii  (int __c)  ;

 

extern int toascii  (int __c)  ;




 
extern int  _toupper   (int)   ;
extern int  _tolower   (int)   ;





























 


# 24 "rpcdebug.c" 2

# 1 "../../support/include/nfslib.h" 1
 











# 1 "/usr/include/sys/socket.h" 1 3











 

 


struct msghdr;

 



int socket  (int __family, int __type, int __protocol)  ;

 




int socketpair  (int __family, int __type, int __protocol,
		int __sockvec[2])  ;

 

int bind  (int __sockfd, __const struct sockaddr *__my_addr,
		int __addrlen)  ;

 



int connect  (int __sockfd, __const struct sockaddr *__serv_addr,
		int __addrlen)  ;

 


int listen  (int __sockfd, int __n)  ;

 




int accept  (int __sockfd, __const struct sockaddr *__peer,
		int *__paddrlen)  ;

 



int getsockopt  (int __s, int __level, int __optname,
		void *__optval, int *__optlen)  ;

 


int setsockopt  (int __s, int __level, int __optname,
		__const void *__optval, int optlen)  ;

 
int getsockname  (int __sockfd, struct sockaddr *__addr,
		int *__paddrlen)  ;

 

int getpeername  (int __sockfd, struct sockaddr *__peer,
		int *__paddrlen)  ;

 
int send  (int __sockfd, __const void *__buff, size_t __len,
		 unsigned int __flags)  ;

 

int recv  (int __sockfd, void *__buff, size_t __len,
		 unsigned int __flags)  ;

 

int sendto  (int __sockfd, __const void *__buff, size_t __len,
		 unsigned int __flags, __const struct sockaddr *__to,
		 int __tolen)  ;

 



int recvfrom  (int __sockfd, void *__buff, size_t __len,
		 unsigned int __flags, struct sockaddr *__from,
		 int *__fromlen)  ;

 

extern int sendmsg  (int __fd, __const struct msghdr *__message,
			unsigned int __flags)  ;

 

extern int recvmsg  (int __fd, struct msghdr *__message,
			unsigned int __flags)  ;
 
 





int shutdown  (int __sockfd, int __how)  ;


 
int rcmd  (char **__ahost, unsigned short __inport,
		__const char *__locuser, __const char *__remuser,
		__const char *__cmd, int *__fd2p)  ;
int rresvport  (int *__port)  ;
int ruserok  (__const char *__rhost, int __superuser,
		__const char *__ruser, __const char *__luser)  ;
int rexec  (char **__ahost, int __inport, __const char *__user,
		 __const char *__passwd, __const char *__cmd,
		 int *__fd2p)  ;

 


# 13 "../../support/include/nfslib.h" 2

# 1 "/usr/include/netinet/in.h" 1 3
 























 

 
enum
  {
    IPPORT_ECHO = 7,		 
    IPPORT_DISCARD = 9,		 
    IPPORT_SYSTAT = 11,		 
    IPPORT_DAYTIME = 13,	 
    IPPORT_NETSTAT = 15,	 
    IPPORT_FTP = 21,		 
    IPPORT_TELNET = 23,		 
    IPPORT_SMTP = 25,		 
    IPPORT_TIMESERVER = 37,	 
    IPPORT_NAMESERVER = 42,	 
    IPPORT_WHOIS = 43,		 
    IPPORT_MTP = 57,

    IPPORT_TFTP = 69,		 
    IPPORT_RJE = 77,
    IPPORT_FINGER = 79,		 
    IPPORT_TTYLINK = 87,
    IPPORT_SUPDUP = 95,		 


    IPPORT_EXECSERVER = 512,	 
    IPPORT_LOGINSERVER = 513,	 
    IPPORT_CMDSERVER = 514,
    IPPORT_EFSSERVER = 520,

     
    IPPORT_BIFFUDP = 512,
    IPPORT_WHOSERVER = 513,
    IPPORT_ROUTESERVER = 520,

     
    IPPORT_RESERVED = 1024,

     
    IPPORT_USERRESERVED = 5000
  };


 





 





 


extern int bindresvport  (int __sockfd,
		struct sockaddr_in * __sin)  ;

 


# 14 "../../support/include/nfslib.h" 2


# 1 "/usr/include/paths.h" 1 3
 











































 






















 





































# 16 "../../support/include/nfslib.h" 2

 

# 1 "/usr/include/linux/nfsd/const.h" 1 3
 












# 1 "/usr/include/linux/unistd.h" 1 3



extern int errno;

 


# 1 "/usr/include/asm/unistd.h" 1 3



 


























































































































































































 










 

# 212 "/usr/include/asm/unistd.h" 3


# 222 "/usr/include/asm/unistd.h" 3


# 232 "/usr/include/asm/unistd.h" 3


# 243 "/usr/include/asm/unistd.h" 3


# 254 "/usr/include/asm/unistd.h" 3


# 266 "/usr/include/asm/unistd.h" 3

# 334 "/usr/include/asm/unistd.h" 3



# 9 "/usr/include/linux/unistd.h" 2 3



# 14 "/usr/include/linux/nfsd/const.h" 2 3

# 1 "/usr/include/linux/dirent.h" 1 3



struct dirent {
	long		d_ino;
	__kernel_off_t	d_off;
	unsigned short	d_reclen;
	char		d_name[256];  
};


# 15 "/usr/include/linux/nfsd/const.h" 2 3




 




 
















# 84 "/usr/include/linux/nfsd/const.h" 3



# 19 "../../support/include/nfslib.h" 2

# 1 "/usr/include/linux/nfsd/syscall.h" 1 3
 














# 1 "/usr/include/linux/nfsd/export.h" 1 3
 
















 






 















# 106 "/usr/include/linux/nfsd/export.h" 3




# 16 "/usr/include/linux/nfsd/syscall.h" 2 3

# 1 "/usr/include/linux/nfsd/nfsfh.h" 1 3
 
















# 1 "/usr/include/linux/string.h" 1 3
# 45 "/usr/include/linux/string.h" 3

# 18 "/usr/include/linux/nfsd/nfsfh.h" 2 3





 





struct nfs_fhbase {
	struct dentry *		fb_dentry;	 
	ino_t			fb_ino;		 
	ino_t			fb_dirino;	 
	dev_t			fb_dev;		 
	dev_t			fb_xdev;
	ino_t			fb_xino;
};


struct knfs_fh {
	struct nfs_fhbase	fh_base;
	__u8			fh_cookie[(32  - sizeof(struct nfs_fhbase)) ];
};








# 169 "/usr/include/linux/nfsd/nfsfh.h" 3



# 17 "/usr/include/linux/nfsd/syscall.h" 2 3

# 1 "/usr/include/linux/nfsd/auth.h" 1 3
 











# 44 "/usr/include/linux/nfsd/auth.h" 3


# 18 "/usr/include/linux/nfsd/syscall.h" 2 3


 




 











 
struct nfsctl_svc {
	unsigned short		svc_port;
	int			svc_nthreads;
};

 
struct nfsctl_client {
	char			cl_ident[1024 +1];
	int			cl_naddr;
	struct in_addr		cl_addrlist[16 ];
	int			cl_fhkeytype;
	int			cl_fhkeylen;
	unsigned char		cl_fhkey[32 ];
};

 
struct nfsctl_export {
	char			ex_client[1024 +1];
	char			ex_path[1024 +1];
	dev_t			ex_dev;
	ino_t			ex_ino;
	int			ex_flags;
	uid_t			ex_anon_uid;
	gid_t			ex_anon_gid;
};

 
struct nfsctl_uidmap {
	char *			ug_ident;
	uid_t			ug_uidbase;
	int			ug_uidlen;
	uid_t *			ug_udimap;
	uid_t			ug_gidbase;
	int			ug_gidlen;
	gid_t *			ug_gdimap;
};

 
struct nfsctl_fhparm {
	struct sockaddr		gf_addr;
	dev_t			gf_dev;
	ino_t			gf_ino;
	int			gf_version;
};

 


struct nfsctl_arg {
	int			ca_version;	 
	union {
		struct nfsctl_svc	u_svc;
		struct nfsctl_client	u_client;
		struct nfsctl_export	u_export;
		struct nfsctl_uidmap	u_umap;
		struct nfsctl_fhparm	u_getfh;
		unsigned int		u_debug;
	} u;







};

union nfsctl_res {
	struct knfs_fh		cr_getfh;
	unsigned int		cr_debug;
};

# 124 "/usr/include/linux/nfsd/syscall.h" 3



# 20 "../../support/include/nfslib.h" 2


# 1 "../../support/include/xlog.h" 1
 
























 

struct xlog_debugfac {
	char		*df_name;
	int		df_fac;
};

void			xlog_open(char *progname);
void			xlog_background(void);
void			xlog_config(int fac, int on);
void			xlog_sconfig(char *, int on);
int			xlog_enabled(int fac);
void			xlog(int fac, const char *fmt, ...);


# 22 "../../support/include/nfslib.h" 2















enum cle_maptypes {
	CLE_MAP_IDENT = 0,
	CLE_MAP_FILE,
	CLE_MAP_UGIDD,
};

 




struct exportent {
	char		e_hostname[1024 +1];
	char		e_path[1024 +1];
	int		e_flags;
	int		e_maptype;
	int		e_anonuid;
	int		e_anongid;
	int *		e_squids;
	int		e_nsquids;
	int *		e_sqgids;
	int		e_nsqgids;
};

struct rmtabent {
	char		r_client[1024 +1];
	char		r_path[1024 +1];
};

 


void			setexportent(char *fname, char *type);
struct exportent *	getexportent(void);
void			putexportent(struct exportent *xep);
void			endexportent(void);
struct exportent *	mkexportent(char *hname, char *path, char *opts);
void			dupexportent(struct exportent *dst,
					struct exportent *src);
int			updateexportent(struct exportent *eep, char *options);

int			setrmtabent(char *type);
struct rmtabent *	getrmtabent(void);
void			putrmtabent(struct rmtabent *xep);
void			endrmtabent(void);
FILE *			fsetrmtabent(char *fname, char *type);
struct rmtabent *	fgetrmtabent(FILE *fp);
void			fputrmtabent(FILE *fp, struct rmtabent *xep);
void			fendrmtabent(FILE *fp);

 


int			wildmat(char *text, char *pattern);

 


int			nfsctl(int, struct nfsctl_arg *, union nfsctl_res *);
int			nfssvc(int port, int nrservs);
int			nfsaddclient(struct nfsctl_client *clp);
int			nfsdelclient(struct nfsctl_client *clp);
int			nfsexport(struct nfsctl_export *exp);
int			nfsunexport(struct nfsctl_export *exp);
struct knfs_fh *	getfh(struct sockaddr *addr, dev_t dev, ino_t ino);


# 25 "rpcdebug.c" 2


static int		verbose = 0;

static int		find_sysname(char *module);
static unsigned int	find_flag(char **module, char *name);
static unsigned int	get_flags(char *);
static unsigned int	set_flags(char *, unsigned int value);
static void		print_flags(FILE *, char *, unsigned int, int);
static char *		strtolower(char *str);
static void		usage(int excode);

int
main(int argc, char **argv)
{
	int		opt_s = 0,
			opt_c = 0;
	unsigned int	flags = 0, oflags;
	char *		module = ((void *)0) ;
	int		c;

	while ((c = getopt(argc, argv, "chm:sv")) != (-1) ) {
		switch (c) {
		case 'c':
			opt_c = 1;
			break;
		case 'h':
			usage(0);
		case 'm':
			module = optarg;
			break;
		case 's':
			opt_s = 1;
			break;
		case 'v':
			verbose++;
			break;
		default:
			fprintf(((_IO_FILE*)(&_IO_stderr_))  , "rpcdebug: unknown option -%c\n",
						optopt);
			usage(1);
		}
	}

	if (opt_c + opt_s > 1) {
		fprintf(((_IO_FILE*)(&_IO_stderr_))  , "You can use at most one of -c and -s\n");
		usage(1);
	}

	if (argc == optind) {
		flags = ~(unsigned int) 0;
	} else {
		for (; optind < argc; optind++)
			flags |= find_flag(&module, argv[optind]);
		if (flags && !opt_c)
			opt_s = 1;
	}

	if (!module) {
		fprintf(((_IO_FILE*)(&_IO_stderr_))  , "rpcdebug: no module name specified, and "
				"could not be inferred.\n");
		usage(1);
	}

	oflags = get_flags(module);

	if (opt_c) {
		oflags = set_flags(module, oflags & ~flags);
	} else if (opt_s) {
		oflags = set_flags(module, oflags | flags);
	}
	print_flags(((_IO_FILE*)(&_IO_stdout_))  , module, oflags, 0);

	return 0;
}






static struct flagmap {
	char *		module;
	char *		name;
	unsigned int	value;
}			flagmap[] = {
	 
	{ "RPC", "XPRT",  0x0001   } ,
	{ "RPC", "CALL",  0x0002   } ,
	{ "RPC", "DEBUG",  0x0004   } ,
	{ "RPC", "NFS",  0x0008   } ,
	{ "RPC", "AUTH",  0x0010   } ,
	{ "RPC", "PMAP",  0x0020   } ,
	{ "RPC", "SCHED",  0x0040   } ,
	{ "RPC", "SVCSOCK",  0x0100   } ,
	{ "RPC", "SVCDSP",  0x0200   } ,
	{ "RPC", "MISC",  0x0400   } ,
	{ "RPC", "ALL",  0x7fff   } ,

	 
	{ "NFS", "VFS",  0x0001   } ,
	{ "NFS", "DIRCACHE",  0x0002   } ,
	{ "NFS", "LOOKUPCACHE",  0x0004   } ,
	{ "NFS", "PAGECACHE",  0x0008   } ,
	{ "NFS", "PROC",  0x0010   } ,
	{ "NFS", "ALL",  0xFFFF   } ,
	{ "NFS", "dir",  0x0002   } ,
	{ "NFS", "lookup",  0x0004   } ,
	{ "NFS", "page",  0x0008   } ,

	 
	{ "NFSD", "SOCK",  0x0001   } ,
	{ "NFSD", "FH",  0x0002   } ,
	{ "NFSD", "EXPORT",  0x0004   } ,
	{ "NFSD", "SVC",  0x0008   } ,
	{ "NFSD", "PROC",  0x0010   } ,
	{ "NFSD", "FILEOP",  0x0020   } ,
	{ "NFSD", "AUTH",  0x0040   } ,
	{ "NFSD", "REPCACHE",  0x0080   } ,
	{ "NFSD", "XDR",  0x0100   } ,
	{ "NFSD", "LOCKD",  0x0200   } ,
	{ "NFSD", "ALL",  0x7FFF   } ,

	 
	{ "NLM", "SVC",  0x0001   } ,
	{ "NLM", "CLIENT",  0x0002   } ,
	{ "NLM", "CLNTLOCK",  0x0004   } ,
	{ "NLM", "SVCLOCK",  0x0008   } ,
	{ "NLM", "MONITOR",  0x0010   } ,
	{ "NLM", "CLNTSUBS",  0x0020   } ,
	{ "NLM", "SVCSUBS",  0x0040   } ,
	{ "NLM", "ALL",  0x7fff   } ,

      { ((void *)0) ,		((void *)0) ,		0 }
};

static unsigned int
find_flag(char **module, char *name)
{
	char		*mod = *module;
	unsigned int	value = 0;
	int		i;

	for (i = 0; flagmap[i].module; i++) {
		if ((mod && strcasecmp(mod, flagmap[i].module))
		 || strcasecmp(name, flagmap[i].name))
			continue;
		if (value) {
			fprintf(((_IO_FILE*)(&_IO_stderr_))  ,
				"rpcdebug: ambiguous symbol name %s.\n"
				"This name is used by more than one module, "
				"please specify the module name using\n"
				"the -m option.\n",
				name);
			usage(1);
		}
		value = flagmap[i].value;
		if (*module)
			return value;
		mod = flagmap[i].module;
	}

	if (!value) {
		if (*module)
			fprintf(((_IO_FILE*)(&_IO_stderr_))  ,
				"rpcdebug: unknown module or flag %s/%s\n",
				*module, name);
		else
			fprintf(((_IO_FILE*)(&_IO_stderr_))  ,
				"rpcdebug: unknown flag %s\n",
				name);
		exit(1);
	}

	*module = mod;
	return value;
}

static unsigned int
get_flags(char *module)
{
	char	buffer[256], *sp;
	int	sysfd, len, namelen;

	if ((sysfd = open("/proc/net/rpc/debug", 00 )) < 0) {
		perror("/proc/net/rpc/debug");
		exit(1);
	}
	if ((len = read(sysfd, buffer, sizeof(buffer))) < 0) {
		perror("read");
		exit(1);
	}
	close(sysfd);
	buffer[len - 1] = '\0';

	namelen = strlen(module);
	for (sp = strtok(buffer, " \t"); sp; sp = strtok(((void *)0) , " \t")) {
		if (!strncmp(sp, module, namelen) && sp[namelen] == '=') {

			return strtoul(sp + namelen + 1, ((void *)0) , 0);
		}
	}

	fprintf(((_IO_FILE*)(&_IO_stderr_))  , "Unknown module %s\n", module);
	exit(1);
}

static unsigned int
set_flags(char *module, unsigned int value)
{
	char	buffer[64];
	int	sysfd, len, ret;

	len = sprintf(buffer, "%s=%u\n", module, value);
	if ((sysfd = open("/proc/net/rpc/debug", 01 )) < 0) {
		perror("/proc/net/rpc/debug");
		exit(1);
	}
	if ((ret = write(sysfd, buffer, len)) < 0) {
		perror("write");
		exit(1);
	}
	if (ret < len) {
		fprintf(((_IO_FILE*)(&_IO_stderr_))  , "error: short write in set_flags!\n");
		exit(1);
	}
	close(sysfd);
	return value;
}

static int
find_sysname(char *module)
{
	char	procname[1024];
	int	fd;

	module = strtolower(module);

	sprintf(procname, "/proc/sys/sunrpc/%s_debug", module);
	if ((fd = open(procname, 02 )) < 0) {
		perror(procname);
		exit(1);
	}

	return fd;
}

static char *
strtolower(char *str)
{
	static char	temp[64];
	char		*sp;

	strcpy(temp, str);
	for (sp = temp; *sp; sp++)
		*sp = ((int) __ctype_tolower[(int) (  *sp  )])  ;
	return temp;
}

static void
print_flags(FILE *ofp, char *module, unsigned int flags, int show_all)
{
	char		*lastmod = ((void *)0) ;
	unsigned int	shown = 0;
	int		i;

	if (module) {
		fprintf(ofp, "%-10s", strtolower(module));
		if (!flags) {
			fprintf(ofp, "<no flags set>\n");
			return;
		}
		 
	}

	for (i = 0, shown = 0; flagmap[i].module; i++) {
		if (module) {
			if (strcasecmp(flagmap[i].module, module))
				continue;
		} else if (!lastmod || strcmp(lastmod, flagmap[i].module)) {
			if (lastmod) {
				fprintf(ofp, "\n");
				shown = 0;
			}
			fprintf(ofp, "%-10s", strtolower(flagmap[i].module));
			lastmod = flagmap[i].module;
		}
		if (!(flags & flagmap[i].value)
		 || (!show_all && (shown & flagmap[i].value))
		 || (module && !strcasecmp(flagmap[i].name, "all")))
			continue;
		fprintf(ofp, " %s", strtolower(flagmap[i].name));
		shown |= flagmap[i].value;
	}
	fprintf(ofp, "\n");
}

static void
usage(int excode)
{
	fprintf(((_IO_FILE*)(&_IO_stderr_))  , "usage: rpcdebug [-m module] [-cs] flags ...\n");
	if (verbose) {
		fprintf(((_IO_FILE*)(&_IO_stderr_))  , "\nModule     Valid flags\n");
		print_flags(((_IO_FILE*)(&_IO_stderr_))  , ((void *)0) , ~(unsigned int) 0, 1);
	} else {
		fprintf(((_IO_FILE*)(&_IO_stderr_))  ,
		    "       (use rpcdebug -vh to get a list of valid flags)\n");
	}
	exit (excode);
}

